﻿using System;  
using System.Collections.Generic;  
using System.Linq;  
using System.Web;
using System.Web.UI; 
using System.Web.UI.WebControls;  
using System.Web.Services;
using System.Text.RegularExpressions;
using System.Reflection;
using HtmlAgilityPack;
using Esnek.BLL;
using Esnek.DAL;

public partial class WebMethods : System.Web.UI.Page, IObjectHandler
{
    private Stack<object> userControlDataStack = new Stack<object>();

    public Stack<object> UserControlDataStack
    {
        get { return userControlDataStack; }
        set { userControlDataStack = value; }
    }

    [WebMethod]
    public static object ZoneToPart(string partroot, string parttype, string basetype, string partname, dynamic mappings)
    {
        Zone partRoot = null;
        PartWithZones partWithZones = null;
        Part part = null;
        string imagePath = null;
        string imageWidth = null;
        string imageHeight = null;
        string title = null;
        string titleHtml = null;
        string text = null;
 
        Dictionary<string, object> PartProperties = new Dictionary<string, object>();
        Dictionary<string, object> PartBindings = new Dictionary<string, object>();

        ContentDataAccess DatabaseManager = new ContentDataAccess();

        foreach (dynamic mapping in mappings)
        {
            if (!mapping.ContainsKey("zoneid")) continue;

            Zone zone = DatabaseManager.GetZone(mapping["zoneid"], false, true);

            if (mapping["type"] == basetype)
            {
                partRoot = zone;
            }

            if (mapping["type"] == "image")
            {
                foreach (CssStyles cssStyle in zone.CssStyles.Controls)
                {
                    if (cssStyle.StyleName == "background")
                    {
                        Regex r1 = new Regex(@"url\([""'](\/.*?\..*?)[""']\)");

                        string style = cssStyle.StyleValue;

                        style = style.Replace("&#39;", "'").Replace("&quot;", "\\\"");

                        MatchCollection matches = r1.Matches(style);

                        foreach (Match match in matches)
                        {
                            if (match.Groups.Count > 1)
                            {
                                imagePath = match.Groups[1].Value;
                            }
                        }

                        /*if (imagePath != null)
                        {
                            DatabaseManager.RemoveControlFactoryProperty(cssStyle.ID);
                        }*/
                    }
                }

                imageWidth = zone.Width.Value.Split(':')[1];
                imageHeight = zone.MinHeight.Value.Split(':')[1];
            }
            else if (mapping["type"] == "text" && (mapping.ContainsKey("property") && (mapping["property"] == "Title" || mapping["property"] == "TitleHtml")))
            {
                if (zone.FormatText != null && CommonMethods.StripHtmlTags(zone.FormatText.Trim()) != string.Empty)
                {
                    title = CommonMethods.StripHtmlTags(zone.FormatText);
                    titleHtml = zone.FormatText;
                }
            }
            /*else if (mapping["type"] == "text")
            {
                if (zone.FormatText != null && CommonMethods.StripHtmlTags(zone.FormatText.Trim()) != string.Empty)
                {
                    text = zone.FormatText;
                }
            }*/

            if (mapping.ContainsKey("block") && !string.IsNullOrWhiteSpace(mapping["block"]))
            {
                DatabaseManager.UpdateInsertObjectProperty(zone.ID, "BlockName", mapping["block"], "String", ObjectTypes.Zone, zone.ContainerID, zone.OwnerID);
            }

            if (mapping.ContainsKey("binding") && !string.IsNullOrWhiteSpace(mapping["binding"]))
            {
                PartBindings[mapping["binding"]] = CommonMethods.StripHtmlTags(zone.FormatText);
                zone.FormatText = InsertBinding(zone.FormatText, mapping["binding"]);
                DatabaseManager.UpdateInsertObjectProperty(zone.ID, "FormatText", zone.FormatText.Replace("'", "''"), "String", ObjectTypes.Zone, zone.ContainerID, zone.OwnerID);
            }

            if (mapping.ContainsKey("property") && !string.IsNullOrWhiteSpace(mapping["property"]))
            {
                PartProperties[mapping["property"]] = CommonMethods.StripHtmlTags(zone.FormatText);
                zone.FormatText = InsertPropertyBinding(zone.FormatText, mapping["property"]);
                DatabaseManager.UpdateInsertObjectProperty(zone.ID, "FormatText", zone.FormatText.Replace("'", "''"), "String", ObjectTypes.Zone, zone.ContainerID, zone.OwnerID);
            }

            DatabaseManager.UpdateInsertObjectProperty(zone.ID, "PartRole", mapping["type"], "String", ObjectTypes.Zone, zone.ContainerID, zone.OwnerID);
        }

        if (partRoot != null)
        {
            if (basetype == "slider")
            {
                Type partType = System.Web.Compilation.BuildManager.GetCompiledType("/sites/default/aspnet/parts/" + parttype + ".ascx");

                object slider = Activator.CreateInstance(partType);

                partType.GetProperty("PartType").SetValue(slider, parttype, null);
                partType.GetProperty("ContainerID").SetValue(slider, partRoot.OwnerID, null);
                partType.GetProperty("AuthorizedRoles").SetValue(slider, "?", null);
                partType.GetProperty("ZoneID").SetValue(slider, partRoot.ID, null);

                if (imagePath != null || PartBindings.Count > 0)
                {
                    PropertyInfo controlFactoryPI = partType.GetProperty("Items");
                    ControlFactory cf = new ControlFactory();
                    TextImage ti = new TextImage();

                    if (PartBindings.Count > 0)
                    {
                        Type textImageType = ti.GetType();
                        foreach (string propertyName in PartBindings.Keys)
                        {
                            try
                            {
                                object val = PartBindings[propertyName];
                                if(string.IsNullOrWhiteSpace((val as string))) continue;
                                PropertyInfo pi = textImageType.GetProperty(propertyName);
                                pi.SetValue(ti, Convert.ChangeType(val, pi.PropertyType), null);
                            }
                            catch { }
                        }
                    }

                    if (imagePath != null) ti.ImageUrl = imagePath;

                    cf.Controls.Add(ti);
                    controlFactoryPI.SetValue(slider, cf, null);
                }

                if (PartProperties.Count > 0)
                {
                    foreach (string propertyName in PartProperties.Keys)
                    {
                        try
                        {
                            object val = PartProperties[propertyName];
                            if (string.IsNullOrWhiteSpace((val as string))) continue;
                            PropertyInfo pi = partType.GetProperty(propertyName);
                            pi.SetValue(slider, Convert.ChangeType(val, pi.PropertyType), null);
                        }
                        catch { }
                    }
                }

                if (!string.IsNullOrWhiteSpace(imageWidth))
                {
                    imageWidth = imageWidth.Replace("px", "").Trim();
                    partType.GetProperty("ThumbnailWidth").SetValue(slider, Convert.ToInt32(imageWidth), null);
                }

                if (!string.IsNullOrWhiteSpace(imageHeight))
                {
                    imageHeight = imageHeight.Replace("px", "").Trim();
                    partType.GetProperty("ThumbnailHeight").SetValue(slider, Convert.ToInt32(imageHeight), null);
                }

                part = (slider as Part);
            } 
            else if (basetype == "list")
            {
                Type partType = System.Web.Compilation.BuildManager.GetCompiledType("/sites/default/aspnet/parts/" + parttype + ".ascx");

                object slider = Activator.CreateInstance(partType);

                partType.GetProperty("PartType").SetValue(slider, parttype, null);
                partType.GetProperty("ContainerID").SetValue(slider, partRoot.OwnerID, null);
                partType.GetProperty("AuthorizedRoles").SetValue(slider, "?", null);
                partType.GetProperty("ZoneID").SetValue(slider, partRoot.ID, null);

                if (PartProperties.Count > 0)
                {
                    foreach (string propertyName in PartProperties.Keys)
                    {
                        try
                        {
                            object val = PartProperties[propertyName];
                            if (string.IsNullOrWhiteSpace((val as string))) continue;
                            PropertyInfo pi = partType.GetProperty(propertyName);
                            pi.SetValue(slider, Convert.ChangeType(val, pi.PropertyType), null);
                        }
                        catch { }
                    }
                }

                if (!string.IsNullOrWhiteSpace(imageWidth))
                {
                    imageWidth = imageWidth.Replace("px", "").Trim();
                    partType.GetProperty("ThumbnailWidth").SetValue(slider, Convert.ToInt32(imageWidth), null);
                }

                if (!string.IsNullOrWhiteSpace(imageHeight))
                {
                    imageHeight = imageHeight.Replace("px", "").Trim();
                    partType.GetProperty("ThumbnailHeight").SetValue(slider, Convert.ToInt32(imageHeight), null);
                }

                part = (slider as Part);
            }
            else if (basetype == "box")
            {
                Type partType = System.Web.Compilation.BuildManager.GetCompiledType("/sites/default/aspnet/parts/" + parttype + ".ascx");

                object box = Activator.CreateInstance(partType);

                partType.GetProperty("PartType").SetValue(box, parttype, null);
                partType.GetProperty("ContainerID").SetValue(box, partRoot.OwnerID, null);
                partType.GetProperty("AuthorizedRoles").SetValue(box, "?", null);
                partType.GetProperty("ZoneID").SetValue(box, partRoot.ID, null);

                if (PartProperties.Count > 0)
                {
                    foreach (string propertyName in PartProperties.Keys)
                    {
                        try
                        {
                            object val = PartProperties[propertyName];
                            if (string.IsNullOrWhiteSpace((val as string))) continue;
                            PropertyInfo pi = partType.GetProperty(propertyName);
                            pi.SetValue(box, Convert.ChangeType(val, pi.PropertyType), null);
                        }
                        catch { }
                    }
                }

                if (!string.IsNullOrWhiteSpace(imageWidth))
                {
                    imageWidth = imageWidth.Replace("px", "").Trim();
                    partType.GetProperty("ImageWidth").SetValue(box, Convert.ToInt32(imageWidth), null);
                }

                if (!string.IsNullOrWhiteSpace(imageHeight))
                {
                    imageHeight = imageHeight.Replace("px", "").Trim();
                    partType.GetProperty("ImageHeight").SetValue(box, Convert.ToInt32(imageHeight), null);
                }

                if (imagePath != null)
                {
                    partType.GetProperty("ImageUrl").SetValue(box, imagePath, null);
                }

                part = (box as Part);
            }
            else if (basetype == "form")
            {
                Type partType = System.Web.Compilation.BuildManager.GetCompiledType("/sites/default/aspnet/parts/" + parttype + ".ascx");

                object form = Activator.CreateInstance(partType);

                partType.GetProperty("PartType").SetValue(form, parttype, null);
                partType.GetProperty("ContainerID").SetValue(form, partRoot.OwnerID, null);
                partType.GetProperty("AuthorizedRoles").SetValue(form, "?", null);
                partType.GetProperty("ZoneID").SetValue(form, partRoot.ID, null);

                if (PartProperties.Count > 0)
                {
                    foreach (string propertyName in PartProperties.Keys)
                    {
                        try
                        {
                            object val = PartProperties[propertyName];
                            if (string.IsNullOrWhiteSpace((val as string))) continue;
                            PropertyInfo pi = partType.GetProperty(propertyName);
                            pi.SetValue(form, Convert.ChangeType(val, pi.PropertyType), null);
                        }
                        catch { }
                    }
                }

                part = (form as Part);
            }
            else
            {
                partWithZones = new PartWithZones();
                partWithZones.PartType = parttype;
                partWithZones.ContainerID = partRoot.OwnerID;
                partWithZones.AuthorizedRoles = "?";
                partWithZones.ZoneID = partRoot.ID;
                part = (partWithZones as Part);
            }            

            DatabaseManager.AddPart(part);

            Type type = System.Web.Compilation.BuildManager.GetCompiledType("/sites/default/aspnet/pages/PartTemplate.aspx");

            object templatePage = Activator.CreateInstance(type);

            type.GetProperty("TemplateName").SetValue(templatePage, "PartTemplate", null);
            type.GetProperty("ContainerID").SetValue(templatePage, "1", null);
            type.GetProperty("Title").SetValue(templatePage, partname, null);

            type.GetProperty("BasePartRole").SetValue(templatePage, basetype, null);
            type.GetProperty("BasePartType").SetValue(templatePage, parttype, null);

            string pageTitle = partname;
            string pagePath = CommonMethods.GetNormalizedUrl(pageTitle).ToLower();
            string newPath = pagePath;
            int ctr = 0;
            while (DatabaseManager.PageExists("/" + newPath, ViewMode.Preview))
            {
                ctr++;
                newPath = pagePath + "-" + ctr.ToString();
            }

            pageTitle = ctr == 0 ? pageTitle : pageTitle + "-" + ctr.ToString();

            string PageUrl = string.Format("/{0}", newPath);

            type.GetProperty("Path").SetValue(templatePage, PageUrl, null);
            type.GetProperty("PageStatus").SetValue(templatePage, 0, null);
            string lastsortno = DatabaseManager.GetLastSortNo("", ObjectTypes.Page);
            type.GetProperty("SortNo").SetValue(templatePage, Convert.ToInt32(lastsortno) + 1, null);
            type.GetProperty("AuthorizedRoles").SetValue(templatePage, "Super User$Site Tasarımcısı", null);

            Esnek.BLL.Page page = (templatePage as Esnek.BLL.Page);

            DatabaseManager.AddPage(page);

            partRoot = DatabaseManager.GetZone(partRoot.ID, true);

            DatabaseManager.MoveZone(partRoot, "1", "1", "1", page.ID);
        }

        return new ZoneToPartResponse() { error = false, refresh = false, href="?view=Part" };
    }

    public static string InsertBinding(string FormatText, string binding)
    {
        HtmlDocument doc = new HtmlDocument();

        if (FormatText != null)
        {
            doc.LoadHtml(FormatText);

            HtmlNode node = doc.DocumentNode;

            bool isparent = false;

            while (node != null && (node.NodeType != HtmlNodeType.Text || node.InnerText.Trim() == string.Empty))
            {
                node = MoveToNext(node, ref isparent);
            }

            if (node != null)
            {
                node.InnerHtml = "[" + binding + "]";
                RemoveSiblings(node);
                return doc.DocumentNode.OuterHtml;
            }
            else return "<p>[" + binding + "]</p>";
        }
                
        return "<p>[" + binding + "]</p>";
    }

    public static string InsertPropertyBinding(string FormatText, string binding)
    {
        HtmlDocument doc = new HtmlDocument();

        if (FormatText != null)
        {
            doc.LoadHtml(FormatText);

            HtmlNode node = doc.DocumentNode;

            bool isparent = false;

            while (node != null && (node.NodeType != HtmlNodeType.Text || node.InnerText.Trim() == string.Empty))
            {
                node = MoveToNext(node, ref isparent);
            }

            if (node != null)
            {
                node.InnerHtml = "{" + binding + "}";
                RemoveSiblings(node);
                return doc.DocumentNode.OuterHtml;
            }
            else return "<p>{" + binding + "}</p>";
        }

        return "<p>{" + binding + "}</p>";
    }

    public static void RemoveSiblings(HtmlNode node)
    {
        while (node.NextSibling != null)
        {
            node.NextSibling.Remove();
        }

        while (node.PreviousSibling != null)
        {
            node.PreviousSibling.Remove();
        }

        if (node.ParentNode != null)
        {
            RemoveSiblings(node.ParentNode);
        }

    }

    public static HtmlNode MoveToNext(HtmlNode node, ref bool isparent)
    {

        if (node.FirstChild != null && !isparent) node = node.FirstChild;
        else if (node.NextSibling != null)
        {
            node = node.NextSibling;
            isparent = false;
        }
        else
        {
            node = node.ParentNode;
            isparent = true;
        }

        return node;
    }

    public Control LoadControl(string virtualPath)
    {
        return new UserControl().LoadControl(virtualPath);
    }

}

public class ZoneToPartResponse
{
    public bool error = false;
    public bool refresh = false;
    public string href = string.Empty;
}
