﻿using System;
using System.Data;
using System.Web.Security;
using System.Net.Mail;
using Esnek.BLL;
using SubSonic;
using SubSonic.Repository;
using SubSonic.Query;
using SubSonic.DataProviders;

public partial class esnek_login : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        ErrorPanel.Visible = false;

        LoginButton.ServerClick += LoginButton_OnClick;
        //ForgotPasswordButton.ServerClick += ForgotPasswordButton_OnClick;
        Esnek.DAL.ContentDataAccess DatabaseManager = new Esnek.DAL.ContentDataAccess();

        ltPageTitle.Text = string.Format(@"<title>{0} :: Yönetici Girişi</title>", DatabaseManager.GetCurrentSite().Name);

    }


    protected void LoginButton_OnClick(object sender, EventArgs e)
    {
        Page.Validate("login-block");
        if (!Page.IsValid) return;

        SimpleRepository repo = new SimpleRepository("esn", SimpleRepositoryOptions.RunMigrations);

        string remoteaddr = Request.UserHostAddress;

        if (remoteaddr == null || remoteaddr.Trim() == string.Empty)
        {
            remoteaddr = "noip";
        }

        LoginAttempt attempt = repo.Single<LoginAttempt>(p => p.ID == remoteaddr);

        if (attempt != null)
        {
            if (attempt.Attempt > 10 && DateTime.Now.Subtract(attempt.LastAttempt).TotalHours < 24) return;
            else if (DateTime.Now.Subtract(attempt.LastAttempt).TotalHours >= 24)
            {
                attempt.Attempt = 0;
                attempt.LastAttempt = DateTime.Now;
                repo.Update(attempt);
            }
        }

        if (Membership.ValidateUser(UserName.Text.Trim(), Password.Text))
        {
            if (attempt != null)
            {
                attempt.Attempt = 0;
                attempt.LastAttempt = DateTime.Now;
                repo.Update(attempt);                
            }

            if (Request.QueryString["ReturnUrl"] != null)
            {
                FormsAuthentication.RedirectFromLoginPage(UserName.Text.Trim(), false);
            }
            else
            {
                FormsAuthentication.SetAuthCookie(UserName.Text.Trim(), false);
                Response.Redirect("/Default.aspx");
            }
        }
        else
        {
            if (UserName.Text.Trim() != string.Empty || Password.Text.Trim() != string.Empty)
            {
                FailureText.Text = "Geçersiz kullanıcı adı veya şifre!";
                ErrorPanel.Visible = true;                

                if (attempt != null)
                {
                    attempt.LastAttempt = DateTime.Now;
                    attempt.Attempt += 1;
                    repo.Update(attempt);
                }
                else
                {
                    attempt = new LoginAttempt();
                    attempt.ID = remoteaddr;
                    attempt.LastAttempt = DateTime.Now;
                    attempt.Attempt += 1;
                    repo.Add(attempt);
                }


            }
        }
    }
}

public class LoginAttempt
{
    [SubSonic.SqlGeneration.Schema.SubSonicPrimaryKey]
    public string ID { get; set; }
    public int Attempt { get; set; }
    public DateTime LastAttempt { get; set; }
}
