﻿using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using Esnek.BLL;
using Esnek.DAL;
using Esnek.Web.UI;
public partial class AdminPanel : System.Web.UI.UserControl
{

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);

        ContentDataAccess DatabaseManager = new ContentDataAccess();

        List<Site> sites = DatabaseManager.GetSites();

        foreach (Site site in sites)
        {
            ListItem li = new ListItem(site.Name, site.Path);
            ddlSites.Items.Add(li);
        }
        
        ddlSites.DataBind();

        ddlSites.SelectedValue = (Page as Esnek.BLL.Page).CurrentSite.Path;

        ddlSites.Attributes["onchange"] = "window.location = this.options[this.selectedIndex].value;";

        List<string> messages = Context.Items["esnErrorMessages"] as List<string>;
        if (messages.Count > 0)
        {
            string alerts = @"<script type=""text/javascript"">";
            foreach (string message in messages)
            {
                alerts += "alert('" + message + "');";
            }

            alerts += string.Format("window.location='{0}';</script>", (Page as Esnek.BLL.Page).Url);

            Page.ClientScript.RegisterClientScriptBlock(Page.GetType(), "esnErrorMessages", alerts);

        }

    }

    protected override void OnLoad(EventArgs e)
    {
        base.OnLoad(e);
        if ((Page as Page).UserProfile.ViewMode != ViewMode.Published)
        {
            LoadEditingData();
        }
        
    }
    public void CreateDropPointsRecursively(List<Zone> Zones,List<string> dropPoints)
    {
        //if(Zones == null) return;
        //foreach (Zone Zone in Zones) {
        //    dropPoints.Add("{dropKey:'Zone" + Zone.ID + "',id:" + Zone.ID + "}");
        //    CreateDropPointsRecursively(Zone.ChildZones,dropPoints);
        //}
    }
     
    public void LoadEditingData()
    {
//        Page pg = (Page) Page;
//        List<string> dropPoints = new List<string>();
//        foreach (string ZoneContainerID in pg.Zones.Keys)
//        {
//            string id = new ContentDataAccess().GetZoneContainerID(ZoneContainerID, pg.UserProfile.ViewMode);
//            dropPoints.Add("{dropKey:'" + ZoneContainerID + "',id:" + id + "}");
//            CreateDropPointsRecursively(pg.Zones[ZoneContainerID], dropPoints);             
//        }

//        string script = 
//      @"<script type='text/javascript'>
//        //<![CDATA[
//        var dropPoints =  new Array(" + string.Join(",",dropPoints.ToArray()) + ");" +
//      @"var dropZones =  new Array({selector: '.dropPoint', accept: '.container, .BoxedText, .Login, .TopMenu, .ImageGallery'});
//        var dragItems =  new Array({dragKey:'container',item:1},{dragKey:'BoxedText',item:2},{dragKey:'Login',item:3},{dragKey:'TopMenu',item:4},{dragKey:'ImageGallery',item:5});
//        //]]>
//        </script>";
//        (this.Page.Master.FindControl("dropAreaScript") as Literal).Text = script;
   } 


}
