﻿using System;
using Esnek.BLL;
using Esnek.DAL;
using System.Text;
using System.Web.UI;
using System.IO;
using System.Web;
using System.Collections.Generic;
using Page = Esnek.BLL.Page;

public partial class ZoneLoader : Esnek.BLL.Page
{
    public long NewPartID = long.MaxValue;

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);

        if (Page.User.Identity.IsAuthenticated && Request.QueryString["ZoneID"] != null && Request.IsLocal)
        {
            ContentDataAccess DatabaseManager = new ContentDataAccess();
            Page pg = (Page)Page;
            string ZoneID = Request.QueryString["ZoneID"];

            List<Zone> zones = DatabaseManager.GetZonesRecursivelyByZoneID(ZoneID, pg.UserProfile.ViewMode);

            if (zones.Count > 0)
            {
                ReIDParts(zones);

                phZoneLoader.Controls.Add(zones[0]);
                StringBuilder b = new StringBuilder();
                HtmlTextWriter h = new HtmlTextWriter(new StringWriter(b));
                zones[0].Container.RenderControl(h);
                Response.Write(b.ToString());
            }

            Response.End();
        }
    }

    private void ReIDParts(List<Zone> zones)
    {
        foreach (Zone zone in zones)
        {
            if (zone.Parts != null && zone.Parts.Count > 0)
            {
                foreach (Part part in zone.Parts)
                {
                    part.ID = NewPartID.ToString();
                    NewPartID--;
                }

            }
            else if (zone.ChildZones != null && zone.ChildZones.Count > 0) ReIDParts(zone.ChildZones);
        }
    }
}
