﻿using System;
using Esnek.DAL;
using Esnek.BLL;
using Esnek.Web.UI;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

public partial class ZoneContainer : System.Web.UI.UserControl
{
    public HtmlGenericControl Container = new HtmlGenericControl("div");  

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);

        ContentDataAccess DatabaseManager = new ContentDataAccess();
        Page pg = (Page)Page;
        string ContainerID = DatabaseManager.GetZoneContainerID(ID, pg.UserProfile.ViewMode);

        //SiteGlobals.t1 = new TimeSpan(DateTime.Now.Ticks).TotalMilliseconds;

        pg.Zones[ID] = DatabaseManager.GetZonesRecursively(ContainerID, pg.ID, pg.UserProfile.ViewMode);

        //SiteGlobals.t2 += new TimeSpan(DateTime.Now.Ticks).TotalMilliseconds - SiteGlobals.t1;

        Container.Attributes.Add("id", ID);
        Container.Attributes.Add("class", "zc zone");
        Controls.Add(Container);
        
        if (pg.Zones[ID] != null)
        {
            foreach (Zone Zone in pg.Zones[ID])
            {
                if (Zone.TargetedTemplates != null && Zone.TargetedTemplates.Controls.Count > 0)
                {
                    bool isTargetedTemplate = false;
                    foreach (TargetedTemplate template in Zone.TargetedTemplates.Controls)
                    {
                        isTargetedTemplate = template.TargetedTemplateName == (Page as Esnek.BLL.Page).TemplateName;
                        if (isTargetedTemplate) break;
                    }
                    if (!isTargetedTemplate) continue;
                }
                Container.Controls.Add(Zone);
            }
        }

    }

    protected override void OnLoad(EventArgs e)
    {
        /*base.OnLoad(e);       
        Response.Write(TimeSpan.FromMilliseconds(SiteGlobals.t2).TotalMilliseconds);
        SiteGlobals.t2 = 0;*/
    }
}
