﻿using System;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using SubSonic;
using SubSonic.Query;
using SubSonic.Repository;
using SubSonic.DataProviders;


    public partial class default_master : System.Web.UI.MasterPage
    {

        protected override void OnInit(EventArgs e)
        {
            ltPageTitle.Text = "<title>" + GetTitle() + "</title>";

            if(Page.User.IsInRole("Site Yöneticisi"))
            {
                AdminPanelArea.Controls.Add(Page.LoadControl("/esn/aspnet/admin/AdminPanel.ascx"));
                AdminPanelArea.Controls.Add(Page.LoadControl("/esn/aspnet/admin/EditorToolbar.ascx"));
            }

            bool isMobile = Request.Browser.IsMobileDevice;

            if (!isMobile)
            {
                if (Request.UserAgent != null && (Request.UserAgent.IndexOf("Sony") >= 0 || Request.UserAgent.IndexOf("Samsung") >= 0 || Request.UserAgent.IndexOf("Nokia") >= 0 || Request.UserAgent.IndexOf("iPhone") >= 0 || Request.UserAgent.IndexOf("mobile") >= 0 || Request.UserAgent.IndexOf("Mobile") >= 0 || Request.UserAgent.IndexOf("Google Wireless Transcoder") >= 0 || Request.UserAgent.IndexOf("MOT-") >= 0))
                {
                    isMobile = true;
                }
            }

            string pageclass = string.Empty;

            if (((Esnek.BLL.Page)Page).UserProfile.ViewMode != Esnek.BLL.ViewMode.Published)
                pageclass = "preview";
            if (Page.User.IsInRole("Super User"))
                pageclass += " superuser";
            if (isMobile)
                pageclass += " ismobile";
            if (pageclass != string.Empty)
                Page.Form.Attributes["class"] = pageclass;


            if (Context.Items.Contains("esnUploadLimit"))
            {
                Page.ClientScript.RegisterStartupScript(Page.GetType(), "uploadLimitError",
                    string.Format(@"BlockUI('GÖNDEREBİLECEĞİNİZ DOSYA BOYUTU MAXIMUM : {0} MB', 4000, true);", Context.Items["esnUploadLimit"].ToString()), true);
                Context.Items.Remove("esnUploadLimit");
            }
                     
            base.OnInit(e);

            string IP = Request.UserHostAddress;

            if (!string.IsNullOrEmpty(IP))
            {
                SimpleRepository repo = new SimpleRepository("esn", SimpleRepositoryOptions.RunMigrations);

                if (!repo.Exists<Visit>(p => p.IP == IP))
                {
                    Visit visit = new Visit();
                    visit.IP = IP;
                    visit.VisitDate = DateTime.Now;
                    repo.Add(visit);
                }

            }

        }

        public string GetSiteVersionID()
        {
            Esnek.DAL.ContentDataAccess DatabaseManager = new Esnek.DAL.ContentDataAccess();
            return DatabaseManager.GetSiteVersionID();
        }

        public string GetTitle()
        {
            Esnek.BLL.Page page = (Page as Esnek.BLL.Page);

            string title = string.Empty;

            if (page.SeoTitle == null || page.SeoTitle.Trim() == string.Empty)
                title = page.CurrentSite.Name + " :: " + page.Title;
            else
                title = page.SeoTitle;

            return title.ToUpper((Page.GetType().GetProperty("CurrentCulture").GetValue(Page, null) as System.Globalization.CultureInfo));

        }

    }
