﻿using System;
using Esnek.BLL;
using SubSonic.DataProviders;
using SubSonic.Query;

namespace Esnek.BLL.PageTemplates
{
    [PageTemplate(Name = "Anasayfa", TemplateName = "Homepage", SortNo = 30, AllowedParents = new string[] { })]
    public partial class Homepage : Page
    {
        private System.Globalization.CultureInfo currentCulture;

        public System.Globalization.CultureInfo CurrentCulture
        {
            get
            {
                if (currentCulture == null)
                {
                    string url = (Page as Esnek.BLL.Page).Url;
                    if (url.StartsWith("/en"))
                    {
                        currentCulture = new System.Globalization.CultureInfo("en-US");

                    }
                    else if (url.StartsWith("/tr"))
                    {
                        currentCulture = new System.Globalization.CultureInfo("tr-TR");
                    }
                    else
                    {
                        currentCulture = System.Globalization.CultureInfo.CurrentCulture;
                    }
                }

                return currentCulture;

            }
        }

    }
}