﻿using System;
using Esnek.BLL;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using System.Web;

namespace Esnek.BLL.PageTemplates
{
    [PageTemplate(Name = "SAYFA", TemplateName = "OneColumn", SortNo = 30)]
    public partial class OneColumn : Page
    {
        [TitledTextBox(Title = "Font Renkleri :", SortNo = 100, TabName=TabNames.Format)]
        public string FontColors
        {
            get { return GetPropertyValue<string>("FontColors"); }
            set { SetPropertyValue<string>("FontColors", value); }
        }

        [TitledTextBox(Title = "Font Büyüklükleri :", SortNo = 200, TabName = TabNames.Format)]
        public string FontSizes
        {
            get { return GetPropertyValue<string>("FontSizes"); }
            set { SetPropertyValue<string>("FontSizes", value); }
        }

        [TitledTextBox(Title = "Google Fontları :", SortNo = 200, TextMode= TextBoxMode.MultiLine, Rows=6, TabName = TabNames.Format)]
        public string GoogleFonts
        {
            get { return GetPropertyValue<string>("GoogleFonts"); }
            set { SetPropertyValue<string>("GoogleFonts", value); }
        }

        [DBProperty]
        public DateTime? FirstViewed
        {
            get { return GetPropertyValue<DateTime?>("FirstViewed"); }
            set { SetPropertyValue<DateTime?>("FirstViewed", value); }
        }

        [DBProperty]
        public string ProcessID
        {
            get { return GetPropertyValue<string>("ProcessID"); }
            set { SetPropertyValue<string>("ProcessID", value); }
        }

        [TextEditor(Title = "Liste Başlığı :", SortNo = 250, Height = "auto")]
        public string ListTitle
        {
            get { return GetPropertyValue<string>("ListTitle"); }
            set { SetPropertyValue<string>("ListTitle", value); }
        }

        [TextEditor(Title = "Liste Metni :", SortNo = 300, Height = "auto")]
        public string ListText
        {
            get { return GetPropertyValue<string>("ListText"); }
            set { SetPropertyValue<string>("ListText", value); }
        }

        [ImageUrlProperty(Title = "Liste Resmi :", SortNo = 350)]
        public string ListImage
        {
            get { return GetPropertyValue<string>("ListImage"); }
            set { SetPropertyValue<string>("ListImage", value); }
        }

        [DateInput(Title = "Eklenme Tarihi :", SortNo = 400)]
        public string DateAdded
        {
            get { return GetPropertyValue<string>("DateAdded"); }
            set { SetPropertyValue<string>("DateAdded", value); }
        }

        [ImageUrlProperty(Title = "Menü İkonu :", SortNo = 450)]
        public string MenuIcon
        {
            get { return GetPropertyValue<string>("MenuIcon"); }
            set { SetPropertyValue<string>("MenuIcon", value); }
        }

        [PageUrlProperty(Title = "Yönlendirme Adresi :", SortNo = 600)]
        public string RedirectUrl
        {
            get { return GetPropertyValue<string>("RedirectUrl", "/"); }
            set { SetPropertyValue<string>("RedirectUrl", value); }
        }

        [DropDownList(Title = "Sayfa Türü", SortNo = 700, Options = new string[] { "OneColumn", "Redirect" })]
        public new string TemplateName
        {
            get { return GetPropertyValue<string>("TemplateName"); }
            set { SetPropertyValue<string>("TemplateName", value); }
        }

        private System.Globalization.CultureInfo currentCulture;

        public System.Globalization.CultureInfo CurrentCulture
        {
            get
            {
                if (currentCulture == null)
                {
                    string url = (Page as Esnek.BLL.Page).Url;
                    if (url.StartsWith("/en"))
                    {
                        currentCulture = new System.Globalization.CultureInfo("en-US");

                    }
                    else if (url.StartsWith("/tr"))
                    {
                        currentCulture = new System.Globalization.CultureInfo("tr-TR");
                    }
                    else
                    {
                        currentCulture = System.Globalization.CultureInfo.CurrentCulture;
                    }
                }

                return currentCulture;

            }
        }

    }
}