﻿using System;
using Esnek.BLL;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using System.Web;

namespace Esnek.BLL.PageTemplates
{
    [PageTemplate(Name = "PARÇA ŞABLONU", TemplateName = "PartTemplate", SortNo = 30)]
    public partial class PartTemplate : Page
    {
        [TitledTextBox(Title = "Temel Parça Rolü :", SortNo = 1000, AuthorizedRoles = new string[] { "Super User" })]
        public string BasePartRole
        {
            get { return GetPropertyValue<string>("BasePartRole"); }
            set { SetPropertyValue<string>("BasePartRole", value); }
        }

        [TitledTextBox(Title = "Temel Parça Tipi :", SortNo = 1100, AuthorizedRoles = new string[] { "Super User" })]
        public string BasePartType
        {
            get { return GetPropertyValue<string>("BasePartType"); }
            set { SetPropertyValue<string>("BasePartType", value); }
        }

        private System.Globalization.CultureInfo currentCulture;

        public System.Globalization.CultureInfo CurrentCulture
        {
            get
            {
                if (currentCulture == null)
                {
                    string url = (Page as Esnek.BLL.Page).Url;
                    if (url.StartsWith("/en"))
                    {
                        currentCulture = new System.Globalization.CultureInfo("en-US");

                    }
                    else if (url.StartsWith("/tr"))
                    {
                        currentCulture = new System.Globalization.CultureInfo("tr-TR");
                    }
                    else
                    {
                        currentCulture = System.Globalization.CultureInfo.CurrentCulture;
                    }
                }

                return currentCulture;

            }
        }
    }
}