﻿using System;
using Esnek.BLL;

namespace Esnek.BLL.PageTemplates
{
    [PageTemplate(Name = "YÖNLENDİRME SAYFASI", TemplateName = "Redirect", SortNo = 60)]
    public partial class Redirect : Page
    {
        [PageUrlProperty(Title = "Yönlendirme Adresi :", IsRequired = true)]
        public string RedirectUrl
        {
            get { return GetPropertyValue<string>("RedirectUrl"); }
            set { SetPropertyValue<string>("RedirectUrl", value); }
        }

        [CheckBox(Title = "Yeni Pencerede Aç :", SortNo = 200)]
        public bool NewWindow
        {
            get { return GetPropertyValue<bool>("NewWindow", false); }
            set { SetPropertyValue<bool>("NewWindow", value); }
        }


        [DropDownList(Title = "Sayfa Türü", SortNo = 700, Options = new string[] { "OneColumn", "Redirect" })]
        public new string TemplateName
        {
            get { return GetPropertyValue<string>("TemplateName"); }
            set { SetPropertyValue<string>("TemplateName", value); }
        }

        private System.Globalization.CultureInfo currentCulture;

        public System.Globalization.CultureInfo CurrentCulture
        {
            get
            {
                if (currentCulture == null)
                {
                    string url = (Page as Esnek.BLL.Page).Url;
                    if (url.StartsWith("/en"))
                    {
                        currentCulture = new System.Globalization.CultureInfo("en-US");

                    }
                    else if (url.StartsWith("/tr"))
                    {
                        currentCulture = new System.Globalization.CultureInfo("tr-TR");
                    }
                    else
                    {
                        currentCulture = System.Globalization.CultureInfo.CurrentCulture;
                    }
                }

                return currentCulture;

            }
        }

    }

    
}