﻿using System;
using System.Web;
using Esnek.BLL;
using Esnek.Web.UI;
using System.Web.UI.WebControls;
using System.Collections.Generic;


namespace Esnek.BLL.PartTemplates
{
    [PartTemplate(Name = "Akordiyon", TemplateName = "Accordion", SortNo = 120, IsDisabled=true)]
    public partial class Accordion : Esnek.BLL.Part
    {

        [TextEditor(Title = "Başlık :", IsRequired = true, SortNo = 100, Height = "auto")]
        public string TitleHtml
        {
            get { return GetPropertyValue<string>("TitleHtml"); }
            set { SetPropertyValue<string>("TitleHtml", value); }
        }

        [TextEditor(Title = "Metin :", Height = "200px", SortNo = 200)]
        public string Text
        {
            get { return GetPropertyValue<string>("Text"); }
            set { SetPropertyValue<string>("Text", value); }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            if (!Page.ClientScript.IsClientScriptBlockRegistered("accordionjs"))
            {
                string accordionjs = @"
<script type=""text/javascript"">
    
    $(function(){

        function setAccordions() {
            var accordions = $('.part.Accordion');

            accordions.each(function () {
                var item = $(this);
                var itemHeader = item.find('.part_header');
                var itemContent = item.find('.part_content');
                itemHeader.click(function () {
                    item.siblings('.current').removeClass('current').find('.part_content').slideUp();
                    itemContent.slideDown();
                    item.addClass('current');
                });
            });

            accordions.first().find('.part_header').trigger('click');
        }

        setAccordions();
    });

</script>";
                Page.ClientScript.RegisterClientScriptBlock(Page.GetType(), "accordionjs", accordionjs);
            }
        }


    }
}