﻿using System;
using System.Web;
using Esnek.BLL;
using Esnek.Web.UI;
using System.Web.UI.WebControls;
using System.Collections.Generic;


namespace Esnek.BLL.PartTemplates
{
    [PartTemplate(Name = "Ses Dosyası", TemplateName = "AudioPlayer", SortNo = 710)]
    public partial class AudioPlayer : Esnek.BLL.Part
    {

        [TitledTextBox(Title = "Başlık :", IsRequired = true, SortNo = 100)]
        public string Title
        {
            get { return GetPropertyValue<string>("Title"); }
            set { SetPropertyValue<string>("Title", value); }
        }

        [CheckBox(Title = "Başlık Görünsün :", SortNo = 200)]
        public bool ShowTitle
        {
            get { return GetPropertyValue<bool>("ShowTitle", false); }
            set { SetPropertyValue<bool>("ShowTitle", value); }
        }

        [ImageUrlProperty(Title = "Ses Dosyası :", IsRequired = true, SortNo = 300)]
        public string VideoUrl
        {
            get { return GetPropertyValue<string>("VideoUrl"); }
            set { SetPropertyValue<string>("VideoUrl", value); }
        }

        [TitledTextBox(Title = "Genişlik :", SortNo = 400, DataType = TypeCode.Int32)]
        public string Width
        {
            get { return GetPropertyValue<string>("Width"); }
            set { SetPropertyValue<string>("Width", value); }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            if (!Page.ClientScript.IsClientScriptIncludeRegistered("mediaplayerjs"))
            {                
                Page.ClientScript.RegisterClientScriptInclude(Page.GetType(), "mediaplayerjs", "/sites/default/js-plugins/mediaplayer/jwplayer.js");
                Page.ClientScript.RegisterClientScriptInclude(Page.GetType(), "mediaplayerjs1", "/sites/default/js-plugins/mediaplayer/swfobject.js");                
            }
        }
    }
}