﻿using System;
using System.Web;
using Esnek.BLL;
using Esnek.Web.UI;
using Esnek.DAL;
using System.Web.UI.WebControls;
using System.Collections.Generic;


namespace Esnek.BLL.PartTemplates
{
    [PartTemplate(Name = "Breadcrumbs", TemplateName = "Breadcrumbs", SortNo = 100, IsDisabled=true)]
    public partial class Breadcrumbs : Esnek.BLL.Part
    {

        [TitledTextBox(Title = "Başlık :", SortNo = 100)]
        public string Title
        {
            get { return GetPropertyValue<string>("Title"); }
            set { SetPropertyValue<string>("Title", value); }
        }

        [PageUrlProperty(Title = "Kök Sayfa :", IsRequired = true, SortNo= 200)]
        public string RootPage
        {
            get {

                string rootPage = GetPropertyValue<string>("RootPage");
                if (string.IsNullOrWhiteSpace(rootPage)) rootPage = "/";
                if (rootPage == "auto")
                {
                    ContentDataAccess DatabaseManager = new ContentDataAccess();
                    rootPage = DatabaseManager.GetPagePath(DatabaseManager.GetZone(this.ContainerID).PageID);
                }
                return rootPage; 
            
            }
            set { SetPropertyValue<string>("RootPage", value); }
        }

        public string CurrentPage { get { return Page != null ? (Page as Esnek.BLL.Page).Url : string.Empty; } }

    }
}