﻿using System;
using System.Web;
using Esnek.BLL;
using Esnek.Web.UI;
using System.Web.UI.WebControls;
using System.Collections.Generic;


namespace Esnek.BLL.PartTemplates
{
    [PartTemplate(Name = "Flash Dosyası(.swf)", TemplateName = "FlashMovie", SortNo = 700)]
    public partial class FlashMovie : Esnek.BLL.Part
    {

        [TitledTextBox(Title = "Başlık :", IsRequired = true, SortNo = 100)]
        public string Title
        {
            get { return GetPropertyValue<string>("Title"); }
            set { SetPropertyValue<string>("Title", value); }
        }

        [CheckBox(Title = "Başlık Görünsün :", SortNo = 200)]
        public bool ShowTitle
        {
            get { return GetPropertyValue<bool>("ShowTitle", false); }
            set { SetPropertyValue<bool>("ShowTitle", value); }
        }

        [ImageUrlProperty(Title = "Flash Dosyası :", SortNo = 300)]
        public string SwfUrl
        {
            get { return GetPropertyValue<string>("SwfUrl"); }
            set { SetPropertyValue<string>("SwfUrl", value); }
        }

        [TitledTextBox(Title = "Genişlik :", IsRequired = true, SortNo = 400)]
        public string Width
        {
            get { return GetPropertyValue<string>("Width"); }
            set { SetPropertyValue<string>("Width", value); }
        }

        [TitledTextBox(Title = "Yükseklik :", IsRequired = true, SortNo = 500)]
        public string Height
        {
            get { return GetPropertyValue<string>("Height"); }
            set { SetPropertyValue<string>("Height", value); }
        }

        [PageUrlProperty(Title = "Bağlantı Adresi :", SortNo = 600)]
        public string LinkUrl
        {
            get { return GetPropertyValue<string>("LinkUrl"); }
            set { SetPropertyValue<string>("LinkUrl", value); }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            if (!Page.ClientScript.IsClientScriptIncludeRegistered("mediaplayerjs"))
            {
                Page.ClientScript.RegisterClientScriptInclude(Page.GetType(), "mediaplayerjs", "/sites/default/js-plugins/mediaplayer/jwplayer.js");
                Page.ClientScript.RegisterClientScriptInclude(Page.GetType(), "mediaplayerjs1", "/sites/default/js-plugins/mediaplayer/swfobject.js");
            }
        }

    }
}