﻿using System;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.UI;
using System.Collections.Generic;
using Esnek.BLL;
using Esnek.BLL.WebControls;
using Esnek.DAL;
using System.Data;
using SubSonic;
using SubSonic.Repository;
using SubSonic.Query;
using SubSonic.DataProviders;
using HtmlAgilityPack;
using System.Text.RegularExpressions;
using System.Text;

namespace Esnek.BLL.PartTemplates
{
    [PartTemplate(Name = "Liste", TemplateName = "ListWithZonesV2", SortNo = 500)]
    public partial class ListWithZonesV2 : PartWithZones
    {

        [TextEditor(Title = "Başlık :", SortNo = 100, Height = "auto")]
        public string TitleHtml
        {
            get { return GetPropertyValue<string>("TitleHtml"); }
            set { SetPropertyValue<string>("TitleHtml", value); }
        }

        [CheckBox(Title = "Başlık Görünsün", SortNo = 200)]
        public bool ShowTitle
        {
            get { return GetPropertyValue<bool>("ShowTitle"); }
            set { SetPropertyValue<bool>("ShowTitle", value); }
        }

        [PageUrlProperty(Title = "Kök Sayfa :", IsRequired = true, SortNo = 300)]
        public string RootPage
        {
            get { return GetPropertyValue<string>("RootPage", "/"); }
            set { SetPropertyValue<string>("RootPage", value); }
        }

        [TitledTextBox(Title = "Liste Limiti :", IsRequired = true, SortNo = 310)]
        public int Limit
        {
            get { return GetPropertyValue<int>("Limit", 0); }
            set { SetPropertyValue<int>("Limit", value); }
        }

        [DropDownList(Title = "Sıralama :", SortNo = 315, Options = new string[] { "SAYFA SIRALAMASI", "EKLENME TARİHİ" })]
        public string OrderBy
        {
            get { return GetPropertyValue<string>("OrderBy", "SAYFA SIRALAMASI"); }
            set { SetPropertyValue<string>("OrderBy", value); }
        }

        [DropDownList(Title = "Tarih Formatı :", SortNo = 320, AuthorizedRoles = new string[] { "Super User" }, Options = new string[] { "dd MMMM yyyy", "dd-MM-yyyy", "dd/MM/yyyy", "dd.MM.yyyy" })]
        public string DateFormat
        {
            get { return GetPropertyValue<string>("DateFormat", "dd MMMM yyyy"); }
            set { SetPropertyValue<string>("DateFormat", value); }
        }

        [CheckBox(Title = "Ön Biçimi Kullan :", SortNo = 330)]
        public bool UseFormatText
        {
            get { return GetPropertyValue<bool>("UseFormatText", true); }
            set { SetPropertyValue<bool>("UseFormatText", value); }
        }

        [TitledTextBox(Title = "Sütün Sayısı :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 350, DataType = TypeCode.Int32)]
        public int Columns
        {
            get { return GetPropertyValue<int>("Columns", 1); }
            set { SetPropertyValue<int>("Columns", value); }
        }

        [TitledTextBox(Title = "Satır Sayısı :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 400, DataType = TypeCode.Int32)]
        public int Rows
        {
            get { return GetPropertyValue<int>("Rows", 1); }
            set { SetPropertyValue<int>("Rows", value); }
        }

        //[CheckBox(Title = "Dikey :", TabName = TabNames.GallerySettings, SortNo = 450)]
        //public bool IsVertical
        //{
        //    get { return GetPropertyValue<bool>("IsVertical", false); }
        //    set { SetPropertyValue<bool>("IsVertical", value); }
        //}

        //[CheckBox(Title = "Mouse Tekeri Etkin :", TabName = TabNames.GallerySettings, SortNo = 500)]
        //public bool ScrollEnabled
        //{
        //    get { return GetPropertyValue<bool>("ScrollEnabled", false); }
        //    set { SetPropertyValue<bool>("ScrollEnabled", value); }
        //}

        //[CheckBox(Title = "Önceki-Sonraki Etkin :", TabName = TabNames.GallerySettings, SortNo = 600)]
        //public bool NextPrevEnabled
        //{
        //    get { return GetPropertyValue<bool>("NextPrevEnabled", true); }
        //    set { SetPropertyValue<bool>("NextPrevEnabled", value); }
        //}

        //[TitledTextBox(Title = "Önceki-Sonraki Pozisyon :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 700, DataType = TypeCode.Int32)]
        //public int NextPrevPosition
        //{
        //    get { return GetPropertyValue<int>("NextPrevPosition", -30); }
        //    set { SetPropertyValue<int>("NextPrevPosition", value); }
        //}

        //[CheckBox(Title = "Navigasyon Etkin :", TabName = TabNames.GallerySettings, SortNo = 800)]
        //public bool NavigationEnabled
        //{
        //    get { return GetPropertyValue<bool>("NavigationEnabled", false); }
        //    set { SetPropertyValue<bool>("NavigationEnabled", value); }
        //}

        [CheckBox(Title = "Otomatik Başlat :", TabName = TabNames.GallerySettings, SortNo = 900)]
        public bool AutoSlideEnabled
        {
            get { return GetPropertyValue<bool>("AutoSlideEnabled", false); }
            set { SetPropertyValue<bool>("AutoSlideEnabled", value); }
        }

        [TitledTextBox(Title = "Slayt Gösterim Süresi :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 1000)]
        public int SliderInterval
        {
            get { return GetPropertyValue<int>("SliderInterval", 5); }
            set { SetPropertyValue<int>("SliderInterval", value); }
        }

        //[CheckBox(Title = "Döngü :", TabName = TabNames.GallerySettings, SortNo = 1100)]
        //public bool IsCircular
        //{
        //    get { return GetPropertyValue<bool>("IsCircular", true); }
        //    set { SetPropertyValue<bool>("IsCircular", value); }
        //}

        [TitledTextBox(Title = "Küçük Resim Genişliği :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 1400, DataType = TypeCode.Int32)]
        public int? ThumbnailWidth
        {
            get { return GetPropertyValue<int?>("ThumbnailWidth"); }
            set { SetPropertyValue<int?>("ThumbnailWidth", value); }
        }

        [TitledTextBox(Title = "Küçük Resim Yüksekliği :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 1500, DataType = TypeCode.Int32)]
        public int? ThumbnailHeight
        {
            get { return GetPropertyValue<int?>("ThumbnailHeight"); }
            set { SetPropertyValue<int?>("ThumbnailHeight", value); }
        }

        /*[TitledTextBox(Title = "Metin Limiti :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 1610)]
        public int? TextLimit
        {
            get { return GetPropertyValue<int?>("TextLimit", 0); }
            set { SetPropertyValue<int?>("TextLimit", value); }
        }*/

        [TitledTextBox(Title = "Detaylar Butonu :", TabName = TabNames.GallerySettings, SortNo = 1750)]
        public string DetailsButton
        {
            get { return GetPropertyValue<string>("DetailsButton"); }
            set { SetPropertyValue<string>("DetailsButton", value); }
        }

        [CheckBox(Title = "Resimleri Kes :", TabName = TabNames.GallerySettings, SortNo = 1800)]
        public bool CropPictures
        {
            get { return GetPropertyValue<bool>("CropPictures", true); }
            set { SetPropertyValue<bool>("CropPictures", value); }
        }

        [CheckBox(Title = "Siyaz Beyaz Efekti :", TabName = TabNames.GallerySettings, SortNo = 2000)]
        public bool HoverBlackWhite
        {
            get { return GetPropertyValue<bool>("HoverBlackWhite", false); }
            set { SetPropertyValue<bool>("HoverBlackWhite", value); }
        }

        [DBProperty]
        public override string ZoneID
        {
            get 
            {
                string znID = GetPropertyValue<string>("ZoneID");
                return !string.IsNullOrWhiteSpace(znID) ? znID : ContentDataAccess.GetDefaultPartZoneMapping(PartType);
            }
            set { SetPropertyValue<string>("ZoneID", value); }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            this.Attributes["class"] += " esnslider ";

            if (!Page.ClientScript.IsClientScriptIncludeRegistered("sliderjs"))
            {
                //Page.ClientScript.RegisterClientScriptBlock(Page.GetType(), "slidercss", @"<link href=""/sites/default/css/image-gallery.css"" type=""text/css"" />");
                Page.ClientScript.RegisterClientScriptInclude(Page.GetType(), "sliderjs", "/sites/default/js/jquery.esnekslider.js");
            }

            ContentDataAccess DatabaseManager = new ContentDataAccess();

            Zone convertedContainer = DatabaseManager.GetZone(ZoneID, true, true, ViewMode.Preview);// (Page as Esnek.BLL.Page).UserProfile.ViewMode);

            if (convertedContainer == null) return;

            convertedContainer.Container.Attributes["class"] += " slider ";

            List<string> PropertyNamesToBind = new List<string>();

            FillPropertyBoundZones(convertedContainer);

            SortChildZones(convertedContainer);

            MarkAsConvertedZone(convertedContainer);

            phlListWithZones.Controls.Add(convertedContainer);

            /*Zone SliderArea = null;

            LoadContainer(convertedContainer, ref SliderArea, "slider");

            if (SliderArea == null) return;*/           

            Zone ItemContainer = null;

            //LoadContainer(SliderArea, ref ItemContainer, "item");
            LoadContainer(convertedContainer, ref ItemContainer, "item");

            if (ItemContainer == null) return;

            List<string> FieldNamesToBind = new List<string>();

            LoadDataBindingInformation(FieldNamesToBind, ItemContainer);

            DataTable dt = GetData(FieldNamesToBind);

            if (dt == null) return;            

            bool hasSortNo = dt.Columns.Contains("SortNo");
            bool hasDateAdded = dt.Columns.Contains("DateAdded");

            List<DataRow> sorter = new List<DataRow>(dt.Select(""));

            if ((OrderBy == "SAYFA SIRALAMASI" && hasSortNo) || (hasSortNo && !hasDateAdded))
            {
                sorter.Sort(delegate(DataRow a, DataRow b)
                {
                    return Convert.ToInt32(a["SortNo"]).CompareTo(Convert.ToInt32(b["SortNo"]));
                });
            }
            else if ((OrderBy == "EKLENME TARİHİ" && hasDateAdded) || (hasDateAdded && !hasSortNo))
            {
                sorter.Sort(delegate(DataRow a, DataRow b)
                {
                    DateTime aD = a["DateAdded"] != DBNull.Value ? Convert.ToDateTime(a["DateAdded"]) : DateTime.MinValue;
                    DateTime bD = b["DateAdded"] != DBNull.Value ? Convert.ToDateTime(b["DateAdded"]) : DateTime.MinValue;
                    return bD.CompareTo(aD);
                });
            }

            if (Limit > 0)
            {
                if (sorter.Count > Limit)
                {
                    sorter.RemoveRange(Limit, sorter.Count - Limit);
                }
            }

            List<DataRow> Items = sorter;
            
            HtmlGenericControl viewport = new HtmlGenericControl("div");
            viewport.Attributes["class"] = "viewport";

            ItemContainer.Parent.Controls.AddAt(ItemContainer.Parent.Controls.IndexOf(ItemContainer), viewport);

            Zone LeftArrowContainer = null;
            Zone RightArrowContainer = null;
            Zone NavigationItem = null;
            Zone NavigationItemText = null;
            Zone NavigationItemActive = null;
            Zone NavigationItemActiveText = null;
            Zone NavigationBlock = null;
            Zone SliderMask = null;
            
            for (int i = 0; i < Items.Count; i++)
            {
                DataRow itemData = Items[i];

                if (itemData["TemplateName"] != DBNull.Value && itemData["TemplateName"].ToString() == "PartTemplate") continue;

                Zone item = CommonMethods.CloneZone(ItemContainer);

                MarkAsConvertedZone(item, false);

                item.Container.Attributes["class"] += (i == 0 ? "first " : "") + "item ";

                LeftArrowContainer = null;
                RightArrowContainer = null;
                NavigationItem = null;
                NavigationItemText = null;
                NavigationItemActive = null;
                NavigationItemActiveText = null;
                NavigationBlock = null;

                SliderMask = null;

                LoadContainers(item, ref LeftArrowContainer, ref RightArrowContainer, ref NavigationItem, ref NavigationItemText, ref NavigationItemActive,
                    ref NavigationItemActiveText, ref NavigationBlock, ref SliderMask);

                if (LeftArrowContainer != null) LeftArrowContainer.Container.Attributes["class"] += " prev ";
                if (RightArrowContainer != null) RightArrowContainer.Container.Attributes["class"] += " next ";

                if (NavigationBlock != null) NavigationBlock.Container.Attributes["class"] += " navi ";
                if (NavigationItem != null) NavigationItem.Container.Attributes["class"] += " navi-item ";
                if (NavigationItemText != null) NavigationItemText.Container.Attributes["class"] += " navi-item-text ";
                if (NavigationItemActive != null) NavigationItemActive.Container.Attributes["class"] += " navi-item-active ";
                if (NavigationItemActiveText != null) NavigationItemActiveText.Container.Attributes["class"] += " navi-item-active-text ";

                if (SliderMask != null) SliderMask.Container.Attributes["class"] += " slider-mask ";

                List<Zone> RemovedZones = new List<Zone>();

                FillItem(item, itemData, ref RemovedZones);

                foreach (Zone removed in RemovedZones)
                    removed.ParentZone.ChildZones.Remove(removed);

                if (HoverBlackWhite)
                    item.Container.Attributes["class"] += " fade-image ";

                viewport.Controls.Add(item);
            }            

            if (NavigationBlock == null)
            {
                LoadContainer(convertedContainer, ref NavigationBlock, "navigation-block", new HashSet<Zone>(new Zone[] { ItemContainer }));
                if (NavigationBlock != null)
                {
                    NavigationBlock.Container.Attributes["class"] += " navi ";

                    LoadContainer(NavigationBlock, ref NavigationItem, "navigation-item");
                    LoadContainer(NavigationBlock, ref NavigationItemText, "navigation-item-text");
                    LoadContainer(NavigationBlock, ref NavigationItemActive, "navigation-item-active");
                    LoadContainer(NavigationBlock, ref NavigationItemActiveText, "navigation-item-active-text");

                    if (NavigationItem != null) NavigationItem.Container.Attributes["class"] += " navi-item ";
                    if (NavigationItemText != null) NavigationItemText.Container.Attributes["class"] += " navi-item-text ";
                    if (NavigationItemActive != null) NavigationItemActive.Container.Attributes["class"] += " navi-item-active ";
                    if (NavigationItemActiveText != null) NavigationItemActiveText.Container.Attributes["class"] += " navi-item-active-text ";
                }
            }

            if (LeftArrowContainer == null)
            {
                LoadContainer(convertedContainer, ref LeftArrowContainer, "left-arrow", new HashSet<Zone>(new Zone[] { ItemContainer }));
                if (LeftArrowContainer != null) LeftArrowContainer.Container.Attributes["class"] += " prev ";
            }

            if (RightArrowContainer == null)
            {
                LoadContainer(convertedContainer, ref RightArrowContainer, "right-arrow", new HashSet<Zone>(new Zone[] { ItemContainer }));
                if (RightArrowContainer != null) RightArrowContainer.Container.Attributes["class"] += " next ";
            }

            if (SliderMask == null)
            {
                LoadContainer(convertedContainer, ref SliderMask, "mask", new HashSet<Zone>(new Zone[] { ItemContainer }));
                if (SliderMask != null) SliderMask.Container.Attributes["class"] += " slider-mask ";
            }

            ItemContainer.Parent.Controls.Remove(ItemContainer);


        }

        public DataTable GetData(List<string> FieldNamesToBind)
        {
            DbDataProvider dbProvider = (DbDataProvider)SubSonic.DataProviders.ProviderFactory.GetProvider("esn");

            string tableSuffix = string.Empty;

            if ((Page as Esnek.BLL.Page).UserProfile.ViewMode != ViewMode.Published)
                tableSuffix = "_preview";

            if (string.IsNullOrEmpty(RootPage)) return null;

            if (RootPage.EndsWith(".aspx")) RootPage = RootPage.Substring(0, RootPage.Length - 5);

            string glob = (RootPage == "/") ? RootPage : RootPage + "/";
            glob += "*";

            string notglob = glob;
            notglob += "/*";

            StringBuilder sb = new StringBuilder();

            if (!FieldNamesToBind.Contains("Path")) FieldNamesToBind.Add("Path");

            if (!FieldNamesToBind.Contains("TemplateName")) FieldNamesToBind.Add("TemplateName");

            if (!FieldNamesToBind.Contains("RedirectUrl")) FieldNamesToBind.Add("RedirectUrl");

            if (!FieldNamesToBind.Contains("SortNo")) FieldNamesToBind.Add("SortNo");

            foreach (string fieldName in FieldNamesToBind)
            {
                sb.AppendFormat(", group_concat(case when PropertyName = '{0}' then Value end) as {0}", fieldName);
            }

            string query = string.Format(
@"
select ObjectID as ID
{0}
    from mak_pages{1} where ObjectID not in (select ID from mak_pages{1} where Type = 'TrashItem') and
    ObjectID in (select ObjectID from mak_pages{1} where PropertyName = 'Path' and Value GLOB '{2}' and Value not GLOB '{3}') group by ObjectID
", sb.ToString(), tableSuffix, glob, notglob);

            QueryCommand q = new QueryCommand(query, dbProvider);

            DataTable dt = dbProvider.ExecuteDataSet(q).Tables[0];

            string redirectPaths = string.Empty;
            string ids = string.Empty;

            foreach(DataRow dr in dt.Rows)
            {
                if (dr["TemplateName"].ToString() == "Redirect") redirectPaths += "'" + dr["RedirectUrl"].ToString().Replace(".aspx", "") + "',";
                else ids += dr["ID"].ToString() + ",";
            }

            if (redirectPaths != string.Empty)
            {
                redirectPaths = redirectPaths.Substring(0, redirectPaths.Length - 1);

                if(ids != string.Empty)
                    ids = ids.Substring(0, ids.Length - 1);

                query = string.Format(
    @"
select ObjectID as ID
{0}
    from mak_pages{1} where ObjectID in ({2}) or
    ObjectID in (select ObjectID from mak_pages{1} where PropertyName = 'Path' and Value in ({3})) group by ObjectID
", sb.ToString(), tableSuffix, ids, redirectPaths);

                q = new QueryCommand(query, dbProvider);

                dt = dbProvider.ExecuteDataSet(q).Tables[0];
            
            }

            return dt;
        }

        public void FillPropertyBoundZones(Zone zone)
        {
            if (zone.ChildZones != null)
            {
                foreach (Zone zn in zone.ChildZones)
                    FillPropertyBoundZones(zn);
            }
            
            if (!string.IsNullOrWhiteSpace(zone.PartRole))
            {
                string formatText = CommonMethods.StripHtmlTags(zone.FormatText);
                if (!string.IsNullOrWhiteSpace(formatText))
                {
                    MatchCollection matches = Regex.Matches(formatText, @"\{(.*?)\}");
                    foreach (Match m in matches)
                    {
                        string pName = m.Value.Trim(new char[] { '{', '}' });
                        try
                        {
                            object value = this.GetType().GetProperty(pName).GetValue(this, null);
                            if (value != null)
                            {
                                string propertyValue = value.ToString();
                                zone.FormatText = zone.FormatText.Replace(m.Value, CommonMethods.StripHtmlTags(propertyValue));
                                zone.Container.InnerHtml = zone.FormatText;
                            }
                            else zone.FormatText = string.Empty;
                        }
                        catch { }
                    }
                }
            }
        }

        public void LoadDataBindingInformation(List<string> FieldNamesToBind, Zone zone)
        {
            if(zone.ChildZones != null) {
                foreach (Zone zn in zone.ChildZones)
                    LoadDataBindingInformation(FieldNamesToBind, zn);
            }

            if (!string.IsNullOrWhiteSpace(zone.PartRole))
            {
                string formatText = CommonMethods.StripHtmlTags(zone.FormatText);
                if (!string.IsNullOrWhiteSpace(formatText))
                {
                    MatchCollection matches = Regex.Matches(formatText, @"\[(.*?)\]");
                    foreach(Match m in matches)
                        FieldNamesToBind.Add(m.Value.Trim(new char[] {'[',']'}));
                }
            }
        }

        public void FillItem(Zone zone, DataRow itemData, ref List<Zone> RemovedZones)
        {
            if (zone.ChildZones != null)
            {
                for (int i = 0; i < zone.ChildZones.Count; i++)
                {
                    Zone child = zone.ChildZones[i];
                    FillItem(child, itemData, ref RemovedZones);
                }
            }

            if (string.IsNullOrWhiteSpace(zone.PartRole)) return;
            if (string.IsNullOrWhiteSpace(CommonMethods.StripHtmlTags(zone.FormatText))) return;

            /*HtmlDocument formatHtml = new HtmlDocument();
            formatHtml.LoadHtml(zone.FormatText);*/

            string itemLink = null;

            if (itemData["Path"] != DBNull.Value)
                itemLink = itemData["Path"].ToString();

            bool hasValue = false;

            MatchCollection matches = Regex.Matches(zone.FormatText, @"\[(.*?)\]");
            foreach (Match m in matches)
            {
                string mValue = m.Value.Trim(new char[] { '[', ']' });
                object data = itemData[mValue];
                string val = data != DBNull.Value ? data.ToString() : null;
                if (val != null && CommonMethods.StripHtmlTags(val).Trim() != string.Empty)
                {
                    hasValue = true;
                    BindZoneData(zone, m, val, itemLink);
                }
            }
            if (matches.Count == 0) { 
                hasValue = true;
                //BindZoneData(zone, null, null, itemLink);
                zone.Container.InnerHtml = zone.FormatText; 
            }

            if (!hasValue)
            {
                if (string.IsNullOrWhiteSpace(zone.BlockName))
                {                    
                    RemovedZones.Add(zone);
                }
                else
                {
                    Zone parent = zone.ParentZone;
                    bool removed = false;
                    while (parent != null)
                    {
                        Zone current = parent;
                        if (current.BlockName == zone.BlockName)
                        {
                            RemovedZones.Add(current);
                            removed = true;
                            break;
                        }
                        parent = current.ParentZone;
                    }
                    if (!removed) 
                        RemovedZones.Add(zone);  
                }
            }

        }

        public void BindZoneData(Zone zone, Match m, string val, string itemLink)
        {
            if (zone.PartRole == "text")
            {
                if (UseFormatText)
                {
                    string pattern = @"\<br\s*\/?\>\s*?\<\/.*?\>";
                    Regex r = new Regex(pattern, RegexOptions.IgnoreCase);
                    val = r.Replace(val, @"\n");

                    pattern = @"(\<\/p\>|\<\/h1\>|\<\/h2\>|\<\/h3\>|\<\/h4\>|\<\/h5\>|\<\/h6\>|\<\/div\>|\<br.*?\>)";
                    r = new Regex(pattern, RegexOptions.IgnoreCase);
                    val = r.Replace(val, @"\n");
                    val = CommonMethods.StripHtmlTags(val);
                    val = val.Replace(@"\n", "<br />");
                    zone.Container.InnerHtml = zone.FormatText.Replace(m.Value, val);
                }
                else
                    zone.Container.InnerHtml = val;

                if (!string.IsNullOrWhiteSpace(itemLink))
                {
                    HtmlGenericControl alink = new HtmlGenericControl("a");
                    alink.Attributes["class"] = " link ";
                    alink.Attributes["href"] = itemLink + ".aspx";
                    zone.Container.Controls.Add(alink);
                }

            }
            else if (zone.PartRole == "image")
            {
                try
                {
                    if (!HoverBlackWhite)
                    {
                        string resizedImage = CommonMethods.GetResizedImagePath(val, (int)ThumbnailWidth, (int)ThumbnailHeight, CropPictures);
                        HtmlImage img = new HtmlImage();
                        img.Src = resizedImage;
                        zone.Container.Controls.Add(img);
                    }
                    else
                    {
                        string resizedImage = CommonMethods.GetResizedImagePath(val, (int)ThumbnailWidth, (int)ThumbnailHeight, CropPictures);
                        HtmlImage img = new HtmlImage();
                        img.Src = resizedImage;
                        img.Attributes["class"] += " fade-image-b";
                        zone.Container.Controls.Add(img);

                        img = new HtmlImage();
                        img.Src = CommonMethods.GetResizedImagePath(val, (int)ThumbnailWidth, (int)ThumbnailHeight, CropPictures, true);
                        img.Attributes["class"] = "fade-image-a";
                        zone.Container.Controls.Add(img);
                    }

                    if (!string.IsNullOrWhiteSpace(itemLink))
                    {
                        HtmlGenericControl alink = new HtmlGenericControl("a");
                        alink.Attributes["class"] = " link ";
                        alink.Attributes["href"] = itemLink + ".aspx";
                        zone.Container.Controls.Add(alink);
                    }

                }
                catch { }

                zone.Container.Attributes["class"] += " image-container ";
            }
            else if (zone.PartRole == "date")
            {
                string pattern = @"\<br\s*\/?\>\s*?\<\/.*?\>";
                Regex r = new Regex(pattern, RegexOptions.IgnoreCase);
                val = r.Replace(val, @"\n");

                pattern = @"(\<\/p\>|\<\/h1\>|\<\/h2\>|\<\/h3\>|\<\/h4\>|\<\/h5\>|\<\/h6\>|\<\/div\>|\<br.*?\>)";
                r = new Regex(pattern, RegexOptions.IgnoreCase);
                val = r.Replace(val, @"\n");
                val = CommonMethods.StripHtmlTags(val);
                val = val.Replace(@"\n", "<br />");
                zone.Container.InnerHtml = zone.FormatText.Replace(m.Value, Convert.ToDateTime(val).ToString(DateFormat));
            }
            else if (zone.PartRole == "link")
            {
                HtmlAnchor link = new HtmlAnchor();
                link.HRef = val.EndsWith(".aspx") ? val : val + ".aspx";
                zone.Container.Controls.Add(link);
                zone.Container.Attributes["class"] += " link ";
                link.Attributes["class"] += " link ";
            }

        }

        public void SortChildZones(Zone zn)
        {
            if (zn.ChildZones != null)
            {
                foreach (Zone child in zn.ChildZones)
                    SortChildZones(child);

                zn.ChildZones.Sort(delegate(Zone a, Zone b)
                {
                    return a.SortNo.CompareTo(b.SortNo);
                });
            }

        }

        public void MarkAsConvertedZone(Zone zn)
        {
            MarkAsConvertedZone(zn, true);
        }

        public void MarkAsConvertedZone(Zone zn, bool deep)
        {
            if (deep && zn.ChildZones != null)
            {
                foreach (Zone child in zn.ChildZones)
                    MarkAsConvertedZone(child, deep);
            }

            string classname = " convertedzone ";
            if (zn.HasClft) classname += "clft ";

            zn.Container.Attributes["class"] += classname;

        }

        public void LoadContainer(Zone container, ref Zone ItemContainer, string partRole)
        {
            LoadContainer(container, ref ItemContainer, partRole, null);
        }

        public void LoadContainer(Zone container, ref Zone ItemContainer, string partRole, HashSet<Zone> not)
        {
            if (container.ChildZones == null) return;

            foreach (Zone zn in container.ChildZones)
            {
                if (not != null)
                {
                    if (not.Contains(zn)) continue;
                }

                if (zn.PartRole == partRole)
                {
                    ItemContainer = zn;
                    break;
                }

                if (zn.ChildZones != null && ItemContainer == null)
                {
                    LoadContainer(zn, ref ItemContainer, partRole, not);
                }
            }
        }

        public void LoadContainers(Zone container, ref Zone LeftArrowContainer, ref Zone RightArrowContainer, ref Zone NavigationItem, ref Zone NavigationItemText, ref Zone NavigationItemActive,
    ref Zone NavigationItemActiveText, ref Zone NavigationBlock, ref Zone SliderMask)
        {
            foreach (Zone zn in container.ChildZones)
            {
                zn.Container.Attributes["class"] += " convertedzone ";

                if (zn.PartRole == "left-arrow")
                {
                    if (LeftArrowContainer == null)
                        LeftArrowContainer = zn;
                }
                else if (zn.PartRole == "right-arrow")
                {
                    if (RightArrowContainer == null)
                        RightArrowContainer = zn;
                }
                else if (zn.PartRole == "navigation-item")
                {
                    if (NavigationItem == null)
                        NavigationItem = zn;
                }
                else if (zn.PartRole == "navigation-item-text")
                {
                    if (NavigationItemText == null)
                        NavigationItemText = zn;
                }
                else if (zn.PartRole == "navigation-item-active")
                {
                    if (NavigationItemActive == null)
                        NavigationItemActive = zn;
                }
                else if (zn.PartRole == "navigation-item-active-text")
                {
                    if (NavigationItemActiveText == null)
                        NavigationItemActiveText = zn;
                }
                else if (zn.PartRole == "navigation-block")
                {
                    if (NavigationBlock == null)
                        NavigationBlock = zn;
                }
                else if (zn.PartRole == "mask")
                {
                    if (SliderMask == null)
                        SliderMask = zn;
                }

                if (zn.ChildZones != null)
                {
                    LoadContainers(zn, ref LeftArrowContainer, ref RightArrowContainer, ref NavigationItem, ref NavigationItemText, ref NavigationItemActive, 
                        ref NavigationItemActiveText, ref NavigationBlock, ref SliderMask);
                }
            }
        }


    }
}
