﻿using System;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Web.UI;
using System.Collections.Generic;
using Esnek.BLL;
using Esnek.BLL.WebControls;
using Esnek.DAL;
using System.Data;
using SubSonic;
using SubSonic.Repository;
using SubSonic.Query;
using SubSonic.DataProviders;
using System.Text.RegularExpressions;

namespace Esnek.BLL.PartTemplates
{
    [PartTemplate(Name = "Resim Galerisi / Slayt", TemplateName = "SliderWithZones", SortNo = 500, IsDisabled= true)]
    public partial class SliderWithZones : PartWithZones
    {
        [TextEditor(Title = "Başlık :", SortNo = 100, Height = "auto")]
        public string TitleHtml
        {
            get { return GetPropertyValue<string>("TitleHtml"); }
            set { SetPropertyValue<string>("TitleHtml", value); }
        }

        [CheckBox(Title = "Başlık Görünsün", SortNo = 200)]
        public bool ShowTitle
        {
            get { return GetPropertyValue<bool>("ShowTitle"); }
            set { SetPropertyValue<bool>("ShowTitle", value); }
        }

        [CheckBox(Title = "Ön Biçimi Kullan :", SortNo = 330)]
        public bool UseFormatText
        {
            get { return GetPropertyValue<bool>("UseFormatText", true); }
            set { SetPropertyValue<bool>("UseFormatText", value); }
        }

        [TitledTextBox(Title = "Sütün Sayısı :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 350, DataType = TypeCode.Int32)]
        public int Columns
        {
            get { return GetPropertyValue<int>("Columns", 1); }
            set { SetPropertyValue<int>("Columns", value); }
        }

        [TitledTextBox(Title = "Satır Sayısı :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 400, DataType = TypeCode.Int32)]
        public int Rows
        {
            get { return GetPropertyValue<int>("Rows", 1); }
            set { SetPropertyValue<int>("Rows", value); }
        }

        //[CheckBox(Title = "Mouse Tekeri Etkin :", TabName = TabNames.GallerySettings, SortNo = 500)]
        //public bool ScrollEnabled
        //{
        //    get { return GetPropertyValue<bool>("ScrollEnabled", false); }
        //    set { SetPropertyValue<bool>("ScrollEnabled", value); }
        //}

        //[CheckBox(Title = "Önceki-Sonraki Etkin :", TabName = TabNames.GallerySettings, SortNo = 600)]
        //public bool NextPrevEnabled
        //{
        //    get { return GetPropertyValue<bool>("NextPrevEnabled", true); }
        //    set { SetPropertyValue<bool>("NextPrevEnabled", value); }
        //}

        //[TitledTextBox(Title = "Önceki-Sonraki Pozisyon :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 700, DataType = TypeCode.Int32)]
        //public int NextPrevPosition
        //{
        //    get { return GetPropertyValue<int>("NextPrevPosition", -30); }
        //    set { SetPropertyValue<int>("NextPrevPosition", value); }
        //}

        //[CheckBox(Title = "Navigasyon Etkin :", TabName = TabNames.GallerySettings, SortNo = 800)]
        //public bool NavigationEnabled
        //{
        //    get { return GetPropertyValue<bool>("NavigationEnabled", false); }
        //    set { SetPropertyValue<bool>("NavigationEnabled", value); }
        //}

        [CheckBox(Title = "Otomatik Başlat :", TabName = TabNames.GallerySettings, SortNo = 900)]
        public bool AutoSlideEnabled
        {
            get { return GetPropertyValue<bool>("AutoSlideEnabled", false); }
            set { SetPropertyValue<bool>("AutoSlideEnabled", value); }
        }

        [TitledTextBox(Title = "Slayt Gösterim Süresi :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 1000)]
        public int SliderInterval
        {
            get { return GetPropertyValue<int>("SliderInterval", 5); }
            set { SetPropertyValue<int>("SliderInterval", value); }
        }

        //[CheckBox(Title = "Döngü :", TabName = TabNames.GallerySettings, SortNo = 1100)]
        //public bool IsCircular
        //{
        //    get { return GetPropertyValue<bool>("IsCircular", true); }
        //    set { SetPropertyValue<bool>("IsCircular", value); }
        //}

        [TitledTextBox(Title = "Küçük Resim Genişliği :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 1400, DataType = TypeCode.Int32)]
        public int? ThumbnailWidth
        {
            get { return GetPropertyValue<int?>("ThumbnailWidth"); }
            set { SetPropertyValue<int?>("ThumbnailWidth", value); }
        }

        [TitledTextBox(Title = "Küçük Resim Yüksekliği :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 1500, DataType = TypeCode.Int32)]
        public int? ThumbnailHeight
        {
            get { return GetPropertyValue<int?>("ThumbnailHeight"); }
            set { SetPropertyValue<int?>("ThumbnailHeight", value); }
        }

        [TitledTextBox(Title = "Büyük Resim Genişliği :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 1600, DataType = TypeCode.Int32)]
        public int ImageWidth
        {
            get { return GetPropertyValue<int>("ImageWidth", 1000); }
            set { SetPropertyValue<int>("ImageWidth", value); }
        }

        [TitledTextBox(Title = "Büyük Resim Yüksekliği :", IsRequired = true, TabName = TabNames.GallerySettings, SortNo = 1700, DataType = TypeCode.Int32)]
        public int ImageHeight
        {
            get { return GetPropertyValue<int>("ImageHeight", 750); }
            set { SetPropertyValue<int>("ImageHeight", value); }
        }

        [TitledTextBox(Title = "Detaylar Butonu :", TabName = TabNames.GallerySettings, SortNo = 1750)]
        public string DetailsButton
        {
            get { return GetPropertyValue<string>("DetailsButton", "Detaylar"); }
            set { SetPropertyValue<string>("DetailsButton", value); }
        }

        [CheckBox(Title = "Resimleri Kes :", TabName = TabNames.GallerySettings, SortNo = 1800)]
        public bool CropPictures
        {
            get { return GetPropertyValue<bool>("CropPictures", true); }
            set { SetPropertyValue<bool>("CropPictures", value); }
        }

        [CheckBox(Title = "Fancybox Etkin :", TabName = TabNames.GallerySettings, SortNo = 1900)]
        public bool FancyboxEnabled
        {
            get { return GetPropertyValue<bool>("FancyboxEnabled", true); }
            set { SetPropertyValue<bool>("FancyboxEnabled", value); }
        }

        [CheckBox(Title = "Siyaz Beyaz Efekti :", TabName = TabNames.GallerySettings, SortNo = 2000)]
        public bool HoverBlackWhite
        {
            get { return GetPropertyValue<bool>("HoverBlackWhite", false); }
            set { SetPropertyValue<bool>("HoverBlackWhite", value); }
        }

        [ControlFactory(Title = "Galeri Resimleri", OutputTypes = new string[] { ControlFactoryOutputTypes.TextImage },
            CssClass = "factory-gallery", TabName = TabNames.GalleryImages)]
        public ControlFactory Items
        {
            get { return GetPropertyValue<ControlFactory>("Items"); }
            set { SetPropertyValue<ControlFactory>("Items", value); }
        }

        [DBProperty]
        public override string ZoneID
        {
            get
            {
                string znID = GetPropertyValue<string>("ZoneID");
                return !string.IsNullOrWhiteSpace(znID) ? znID : ContentDataAccess.GetDefaultPartZoneMapping(PartType);
            }
            set { SetPropertyValue<string>("ZoneID", value); }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            this.Attributes["class"] += " esnslider ";

            if (!Page.ClientScript.IsClientScriptIncludeRegistered("sliderjs"))
            {
                //Page.ClientScript.RegisterClientScriptBlock(Page.GetType(), "slidercss", @"<link href=""/sites/default/css/image-gallery.css"" type=""text/css"" />");
                Page.ClientScript.RegisterClientScriptInclude(Page.GetType(), "sliderjs", "/sites/default/js/jquery.esnekslider.js?v=2");
            }

            ContentDataAccess DatabaseManager = new ContentDataAccess();

            if(string.IsNullOrWhiteSpace(ZoneID)) return;

            Zone convertedContainer = DatabaseManager.GetZone(ZoneID, true, true, ViewMode.Preview);// (Page as Esnek.BLL.Page).UserProfile.ViewMode);

            if (convertedContainer == null) return;

            convertedContainer.Container.Attributes["class"] += " slider ";

            //List<string> PropertyNamesToBind = new List<string>();

            FillPropertyBoundZones(convertedContainer);

            SortChildZones(convertedContainer);

            MarkAsConvertedZone(convertedContainer);

            phlListWithZones.Controls.Add(convertedContainer);

            Zone ItemContainer = null;

            LoadContainer(convertedContainer, ref ItemContainer, "item");

            if (ItemContainer == null) return;

            //List<string> FieldNamesToBind = new List<string>();

            //LoadDataBindingInformation(FieldNamesToBind, ItemContainer);

            //DataTable dt = GetData(FieldNamesToBind);

            HtmlGenericControl viewport = new HtmlGenericControl("div");
            viewport.Attributes["class"] = "viewport";

            ItemContainer.Parent.Controls.AddAt(ItemContainer.Parent.Controls.IndexOf(ItemContainer), viewport);

            Zone LeftArrowContainer = null;
            Zone RightArrowContainer = null;
            Zone NavigationItem = null;
            Zone NavigationItemText = null;
            Zone NavigationItemActive = null;
            Zone NavigationItemActiveText = null;
            Zone NavigationBlock = null;
            Zone SliderMask = null;

            for (int i = 0; i < Items.Controls.Count; i++)
            {
                TextImage itemData = (TextImage)Items.Controls[i];

                Zone item = CommonMethods.CloneZone(ItemContainer);

                MarkAsConvertedZone(item, false);

                item.Container.Attributes["class"] += (i == 0 ? "first " : "") + "item ";

                LeftArrowContainer = null;
                RightArrowContainer = null;
                NavigationItem = null;
                NavigationItemText = null;
                NavigationItemActive = null;
                NavigationItemActiveText = null;
                NavigationBlock = null;

                SliderMask = null;

                LoadContainers(item, ref LeftArrowContainer, ref RightArrowContainer, ref NavigationItem, ref NavigationItemText, ref NavigationItemActive,
                    ref NavigationItemActiveText, ref NavigationBlock, ref SliderMask);

                if (LeftArrowContainer != null) LeftArrowContainer.Container.Attributes["class"] += " prev ";
                if (RightArrowContainer != null) RightArrowContainer.Container.Attributes["class"] += " next ";

                if (NavigationBlock != null) NavigationBlock.Container.Attributes["class"] += " navi ";
                if (NavigationItem != null) NavigationItem.Container.Attributes["class"] += " navi-item ";
                if (NavigationItemText != null) NavigationItemText.Container.Attributes["class"] += " navi-item-text ";
                if (NavigationItemActive != null) NavigationItemActive.Container.Attributes["class"] += " navi-item-active ";
                if (NavigationItemActiveText != null) NavigationItemActiveText.Container.Attributes["class"] += " navi-item-active-text ";

                if (SliderMask != null) SliderMask.Container.Attributes["class"] += " slider-mask ";

                List<Zone> RemovedZones = new List<Zone>();

                FillItem(item, itemData, ref RemovedZones);

                foreach (Zone removed in RemovedZones)
                    removed.ParentZone.ChildZones.Remove(removed);

                if (HoverBlackWhite)
                    item.Container.Attributes["class"] += " fade-image ";

                viewport.Controls.Add(item);
            }

            if (NavigationBlock == null)
            {
                LoadContainer(convertedContainer, ref NavigationBlock, "navigation-block", new HashSet<Zone>(new Zone[] { ItemContainer }));
                if (NavigationBlock != null)
                {
                    NavigationBlock.Container.Attributes["class"] += " navi ";

                    LoadContainer(NavigationBlock, ref NavigationItem, "navigation-item");
                    LoadContainer(NavigationBlock, ref NavigationItemText, "navigation-item-text");
                    LoadContainer(NavigationBlock, ref NavigationItemActive, "navigation-item-active");
                    LoadContainer(NavigationBlock, ref NavigationItemActiveText, "navigation-item-active-text");

                    if (NavigationItem != null) NavigationItem.Container.Attributes["class"] += " navi-item ";
                    if (NavigationItemText != null) NavigationItemText.Container.Attributes["class"] += " navi-item-text ";
                    if (NavigationItemActive != null) NavigationItemActive.Container.Attributes["class"] += " navi-item-active ";
                    if (NavigationItemActiveText != null) NavigationItemActiveText.Container.Attributes["class"] += " navi-item-active-text ";
                }
            }

            if (LeftArrowContainer == null)
            {
                LoadContainer(convertedContainer, ref LeftArrowContainer, "left-arrow", new HashSet<Zone>(new Zone[] { ItemContainer }));
                if (LeftArrowContainer != null) LeftArrowContainer.Container.Attributes["class"] += " prev ";
            }

            if (RightArrowContainer == null)
            {
                LoadContainer(convertedContainer, ref RightArrowContainer, "right-arrow", new HashSet<Zone>(new Zone[] { ItemContainer }));
                if (RightArrowContainer != null) RightArrowContainer.Container.Attributes["class"] += " next ";
            }

            if (SliderMask == null)
            {
                LoadContainer(convertedContainer, ref SliderMask, "mask", new HashSet<Zone>(new Zone[] { ItemContainer }));
                if (SliderMask != null) SliderMask.Container.Attributes["class"] += " slider-mask ";
            }

            ItemContainer.Parent.Controls.Remove(ItemContainer);

        }

        public void FillPropertyBoundZones(Zone zone)
        {
            if (zone.ChildZones != null)
            {
                foreach (Zone zn in zone.ChildZones)
                    FillPropertyBoundZones(zn);
            }

            if (!string.IsNullOrWhiteSpace(zone.PartRole))
            {
                string formatText = CommonMethods.StripHtmlTags(zone.FormatText);
                if (!string.IsNullOrWhiteSpace(formatText))
                {
                    MatchCollection matches = Regex.Matches(formatText, @"\{(.*?)\}");
                    foreach (Match m in matches)
                    {
                        string pName = m.Value.Trim(new char[] { '{', '}' });
                        try
                        {
                            object value = this.GetType().GetProperty(pName).GetValue(this, null);
                            if (value != null)
                            {
                                string propertyValue = value.ToString();
                                zone.FormatText = zone.FormatText.Replace(m.Value, CommonMethods.StripHtmlTags(propertyValue));
                                zone.Container.InnerHtml = zone.FormatText;
                            }
                            else zone.FormatText = string.Empty;
                        }
                        catch { }
                    }
                }
            }
        }

        public void LoadDataBindingInformation(List<string> FieldNamesToBind, Zone zone)
        {
            if (zone.ChildZones != null)
            {
                foreach (Zone zn in zone.ChildZones)
                    LoadDataBindingInformation(FieldNamesToBind, zn);
            }

            if (!string.IsNullOrWhiteSpace(zone.PartRole))
            {
                string formatText = CommonMethods.StripHtmlTags(zone.FormatText);
                if (!string.IsNullOrWhiteSpace(formatText))
                {
                    MatchCollection matches = Regex.Matches(formatText, @"\[(.*?)\]");
                    foreach (Match m in matches)
                        FieldNamesToBind.Add(m.Value.Trim(new char[] { '[', ']' }));
                }
            }
        }

        public void FillItem(Zone zone, TextImage itemData, ref List<Zone> RemovedZones)
        {
            if (zone.ChildZones != null)
            {
                for (int i = 0; i < zone.ChildZones.Count; i++)
                {
                    Zone child = zone.ChildZones[i];
                    FillItem(child, itemData, ref RemovedZones);
                }
            }

            if (string.IsNullOrWhiteSpace(zone.PartRole)) return;
            if (string.IsNullOrWhiteSpace(CommonMethods.StripHtmlTags(zone.FormatText))) return;

            /*HtmlDocument formatHtml = new HtmlDocument();
            formatHtml.LoadHtml(zone.FormatText);*/

            string itemLink = itemData.ImageLink;

            /*if (itemData["Path"] != DBNull.Value)
                itemLink = itemData["Path"].ToString();*/

            bool hasValue = false;

            MatchCollection matches = Regex.Matches(zone.FormatText, @"\[(.*?)\]");
            foreach (Match m in matches)
            {
                string mValue = m.Value.Trim(new char[] { '[', ']' });
                System.Reflection.PropertyInfo obprop = itemData.GetType().GetProperty(mValue);
                object data = obprop != null ? obprop.GetValue(itemData, null) : null;
                string val = data != null ? data.ToString() : null;
                if (val != null && CommonMethods.StripHtmlTags(val).Trim() != string.Empty)
                {
                    hasValue = true;
                    BindZoneData(zone, m, val, itemLink);
                }
            }
            if (matches.Count == 0 && !string.IsNullOrWhiteSpace(itemLink))
            {
                hasValue = true;
                //BindZoneData(zone, null, null, itemLink);
                zone.Container.InnerHtml = zone.FormatText;
            }

            if (!hasValue)
            {
                if (string.IsNullOrWhiteSpace(zone.BlockName))
                {
                    RemovedZones.Add(zone);
                }
                else
                {
                    Zone parent = zone.ParentZone;
                    bool removed = false;
                    while (parent != null)
                    {
                        Zone current = parent;
                        if (current.BlockName == zone.BlockName)
                        {
                            RemovedZones.Add(current);
                            removed = true;
                            break;
                        }
                        parent = current.ParentZone;
                    }
                    if (!removed)
                        RemovedZones.Add(zone);
                }
            }
        }

        public void BindZoneData(Zone zone, Match m, string val, string itemLink)
        {
            if (zone.PartRole == "text")
            {
                if (UseFormatText)
                {
                    string pattern = @"\<br\s*\/?\>\s*?\<\/.*?\>";
                    Regex r = new Regex(pattern, RegexOptions.IgnoreCase);
                    val = r.Replace(val, @"\n");

                    pattern = @"(\<\/p\>|\<\/h1\>|\<\/h2\>|\<\/h3\>|\<\/h4\>|\<\/h5\>|\<\/h6\>|\<\/div\>|\<br.*?\>)";
                    r = new Regex(pattern, RegexOptions.IgnoreCase);
                    val = r.Replace(val, @"\n");
                    val = CommonMethods.StripHtmlTags(val);
                    val = val.Replace(@"\n", "<br />");
                    zone.Container.InnerHtml = zone.FormatText.Replace(m.Value, val);
                }
                else
                    zone.Container.InnerHtml = val;

                if (!string.IsNullOrWhiteSpace(itemLink))
                {
                    HtmlGenericControl alink = new HtmlGenericControl("a");
                    alink.Attributes["class"] = " link ";
                    alink.Attributes["href"] = itemLink;
                    zone.Container.Controls.Add(alink);
                }
            }
            else if (zone.PartRole == "image")
            {
                try
                {
                    if (!HoverBlackWhite)
                    {
                        string resizedImage = CommonMethods.GetResizedImagePath(val, (int)ThumbnailWidth, (int)ThumbnailHeight, CropPictures);
                        HtmlImage img = new HtmlImage();
                        img.Src = resizedImage;
                        zone.Container.Controls.Add(img);
                    }
                    else
                    {
                        string resizedImage = CommonMethods.GetResizedImagePath(val, (int)ThumbnailWidth, (int)ThumbnailHeight, CropPictures);
                        HtmlImage img = new HtmlImage();
                        img.Src = resizedImage;
                        img.Attributes["class"] += " fade-image-b";
                        zone.Container.Controls.Add(img);

                        img = new HtmlImage();
                        img.Src = CommonMethods.GetResizedImagePath(val, (int)ThumbnailWidth, (int)ThumbnailHeight, CropPictures, true);
                        img.Attributes["class"] = "fade-image-a";
                        zone.Container.Controls.Add(img);
                    }

                    if (!string.IsNullOrWhiteSpace(itemLink))
                    {
                        HtmlGenericControl alink = new HtmlGenericControl("a");
                        alink.Attributes["class"] = " link ";
                        alink.Attributes["href"] = itemLink;
                        zone.Container.Controls.Add(alink);
                    }
                    else if (FancyboxEnabled)
                    {
                        HtmlGenericControl alink = new HtmlGenericControl("a");
                        alink.Attributes["href"] = CommonMethods.GetResizedImagePath(val, ImageWidth, ImageHeight, false);
                        alink.Attributes["class"] = " link ";
                        alink.Attributes["rel"] = "fancy" + ID;
                        zone.Container.Controls.Add(alink);
                    }
                }
                catch { }
              
                zone.Container.Attributes["class"] += " image-container ";
            }
            /*else if (zone.PartRole == "date")
            {
                string pattern = @"\<br\s*\/?\>\s*?\<\/.*?\>";
                Regex r = new Regex(pattern, RegexOptions.IgnoreCase);
                val = r.Replace(val, @"\n");

                pattern = @"(\<\/p\>|\<\/h1\>|\<\/h2\>|\<\/h3\>|\<\/h4\>|\<\/h5\>|\<\/h6\>|\<\/div\>|\<br.*?\>)";
                r = new Regex(pattern, RegexOptions.IgnoreCase);
                val = r.Replace(val, @"\n");
                val = CommonMethods.StripHtmlTags(val);
                val = val.Replace(@"\n", "<br />");
                zone.Container.InnerHtml = zone.FormatText.Replace(m.Value, Convert.ToDateTime(val).ToString(DateFormat));
            }*/
            else if (zone.PartRole == "link")
            {
                HtmlAnchor link = new HtmlAnchor();
                link.HRef = val.EndsWith(".aspx") ? val : val + ".aspx";
                zone.Container.Controls.Add(link);
                zone.Container.Attributes["class"] += " link ";
                link.Attributes["class"] += " link ";
            }
        }

        public void SortChildZones(Zone zn)
        {
            if (zn.ChildZones != null)
            {
                foreach (Zone child in zn.ChildZones)
                    SortChildZones(child);

                zn.ChildZones.Sort(delegate(Zone a, Zone b)
                {
                    return a.SortNo.CompareTo(b.SortNo);
                });
            }

        }

        public void MarkAsConvertedZone(Zone zn)
        {
            MarkAsConvertedZone(zn, true);
        }

        public void MarkAsConvertedZone(Zone zn, bool deep)
        {
            if (deep && zn.ChildZones != null)
            {
                foreach (Zone child in zn.ChildZones)
                    MarkAsConvertedZone(child, deep);
            }

            string classname = " convertedzone ";
            if (zn.HasClft) classname += "clft ";

            zn.Container.Attributes["class"] += classname;

        }

        public void LoadContainer(Zone container, ref Zone ItemContainer, string partRole)
        {
            LoadContainer(container, ref ItemContainer, partRole, null);
        }

        public void LoadContainer(Zone container, ref Zone ItemContainer, string partRole, HashSet<Zone> not)
        {
            if (container.ChildZones == null) return;

            foreach (Zone zn in container.ChildZones)
            {
                if (not != null)
                {
                    if (not.Contains(zn)) continue;
                }

                if (zn.PartRole == partRole)
                {
                    ItemContainer = zn;
                    break;
                }

                if (zn.ChildZones != null && ItemContainer == null)
                {
                    LoadContainer(zn, ref ItemContainer, partRole, not);
                }
            }
        }

        public void LoadContainers(Zone container, ref Zone LeftArrowContainer, ref Zone RightArrowContainer, ref Zone NavigationItem, ref Zone NavigationItemText, ref Zone NavigationItemActive,
    ref Zone NavigationItemActiveText, ref Zone NavigationBlock, ref Zone SliderMask)
        {
            foreach (Zone zn in container.ChildZones)
            {
                zn.Container.Attributes["class"] += " convertedzone ";

                if (zn.PartRole == "left-arrow")
                {
                    if (LeftArrowContainer == null)
                        LeftArrowContainer = zn;
                }
                else if (zn.PartRole == "right-arrow")
                {
                    if (RightArrowContainer == null)
                        RightArrowContainer = zn;
                }
                else if (zn.PartRole == "navigation-item")
                {
                    if (NavigationItem == null)
                        NavigationItem = zn;
                }
                else if (zn.PartRole == "navigation-item-text")
                {
                    if (NavigationItemText == null)
                        NavigationItemText = zn;
                }
                else if (zn.PartRole == "navigation-item-active")
                {
                    if (NavigationItemActive == null)
                        NavigationItemActive = zn;
                }
                else if (zn.PartRole == "navigation-item-active-text")
                {
                    if (NavigationItemActiveText == null)
                        NavigationItemActiveText = zn;
                }
                else if (zn.PartRole == "navigation-block")
                {
                    if (NavigationBlock == null)
                        NavigationBlock = zn;
                }
                else if (zn.PartRole == "mask")
                {
                    if (SliderMask == null)
                        SliderMask = zn;
                }

                if (zn.ChildZones != null)
                {
                    LoadContainers(zn, ref LeftArrowContainer, ref RightArrowContainer, ref NavigationItem, ref NavigationItemText, ref NavigationItemActive,
                        ref NavigationItemActiveText, ref NavigationBlock, ref SliderMask);
                }
            }
        }
    }
}
