﻿using System;
using System.Web;
using Esnek.BLL;
using Esnek.Web.UI;
using System.Web.UI.WebControls;
using System.Collections.Generic;


namespace Esnek.BLL.PartTemplates
{
    [PartTemplate(Name = "Tab Sayfası", TemplateName = "TabPage", SortNo = 110, IsDisabled = true)]
    public partial class TabPage : Esnek.BLL.Part
    {

        [TitledTextBox(Title = "Başlık :", SortNo = 100, IsRequired=true)]
        public string Title
        {
            get { return GetPropertyValue<string>("Title"); }
            set { SetPropertyValue<string>("Title", value); }
        }

        [TextEditor(Title = "Metin :", Height = "200px", SortNo = 200)]
        public string Text
        {
            get { return GetPropertyValue<string>("Text"); }
            set { SetPropertyValue<string>("Text", value); }
        }

        /*[CheckBox(Title = "Transparan Arkaplan :", SortNo = 300)]
        public bool TransparentBackground
        {
            get { return GetPropertyValue<bool>("TransparentBackground", true); }
            set { SetPropertyValue<bool>("TransparentBackground", value); }
        }*/



        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            if (!Page.ClientScript.IsClientScriptBlockRegistered("tabpagejs"))
            {
                string tabpagejs = @"
<script type=""text/javascript"">

    $(function(){

        function setTabPages() {

            var tabsarr = [];
            var tabs = null;

            $('.part.TabPage').each(function () {

                if (tabs == null) {
                    tabs = $(this);

                } else {

                    if (this == tabs.last().next().get(0)) {
                        tabs = tabs.add(this);
                    }
                    else {
                        tabsarr.push(tabs);
                        tabs = $(this);
                    }
                }
            });

            if (tabs != null) {

                tabsarr.push(tabs);

                for (var i = 0; i < tabsarr.length; i++) {

                    var tabs = tabsarr[i];

                    var tabswrap = $('<div class=""tabswrap""></div>');
                    var tabsbuttons = $('<div class=""tabsbuttons""></div>');
                    tabswrap.insertBefore(tabs.first());
                    tabswrap.append(tabsbuttons);
                    tabsbuttons.append(tabs.find('.part_header'));
                    tabsbuttons.find('.part_header').first().addClass('current');
                    tabsbuttons.append('<div class=""clear""></div>');
                    tabswrap.append(tabs);
                    tabs.first().css('display', 'block');
                    tabsbuttons.find('.tabbutton').click(function (e) {

                        tabsbuttons.find('.part_header').removeClass('current');

                        tabs.css('display', 'none');

                        var tabID = $(this).attr('id').replace('tabpage-', 'Part');

                        $(this).parents('.part_header').first().addClass('current');

                        tabswrap.find('#' + tabID).css('display', 'block');

                    });
                }
            }
        }

        setTabPages();
    });

</script>";
                Page.ClientScript.RegisterClientScriptBlock(Page.GetType(), "tabpagejs", tabpagejs);                
            }
        }


    }
}