/*! Copyright (c) 2014 Esnek Yazilim (http://esnekyazilim.com)
*/

(function ($) {

    $.fn.EsnekForm = function (options) {

        /*var settings = $.extend({
            
        }, options);*/

        this.each(function () {

            var part = $(this);

            var items = part.find(".field-item");

            items.each(function () {

                var item = $(this);
                var itemTitle = item.find(".item-title");
                var itemInput = item.find(".item-input");
                if (itemTitle.size() > 0) {
                    var itemTitleRect = itemTitle.get(0).getBoundingClientRect();
                    var itemInputRect = itemInput.get(0).getBoundingClientRect();

                    itemTitle.css({ zIndex: 0 });
                    itemInput.css({ zIndex: 1 });

                    if (itemTitleRect.right > itemInputRect.left && itemTitleRect.bottom > itemInputRect.top && itemTitleRect.left < itemInputRect.right && itemTitleRect.top < itemInputRect.bottom) {

                        var itemRect = this.getBoundingClientRect();

                        var input = itemInput.find(".input-control");

                        var activeState = item.siblings(".field-item-active");



                        if (activeState.size() > 0) {

                            makeActiveState(item, input, activeState, itemTitle);

                        } else {

                            input.bind("focus", function () { itemTitle.css("visibility", "hidden"); });
                            input.bind("focusout", function () {
                                hideTitle(itemTitle, input);
                            });
                        }

                        hideTitle(itemTitle, input);
                    }
                    else {

                        var input = itemInput.find(".input-control");

                        var activeState = item.siblings(".field-item-active");

                        if (activeState.size() > 0) {

                            makeActiveState(item, input, activeState, itemTitle);
                        }

                    }
                } else {

                    var input = itemInput.find(".input-control");

                    var activeState = item.siblings(".field-item-active");

                    if (activeState.size() > 0) {

                        makeActiveState(item, input, activeState, null);
                    }
                }
            });

            var buttonItems = part.find(".button-item");

            buttonItems.each(function () {

                var buttonItem = $(this);
                var buttonItemActive = buttonItem.siblings(".button-item-active");
                if (buttonItemActive.size() > 0) {

                    buttonItem.parent().hover(function () {

                        buttonItem.css({ display: "none" });
                        buttonItemActive.css({ display: "block" });

                    }, function () {

                        buttonItemActive.css({ display: "none" });
                        buttonItem.css({ display: "block" });

                    });


                }

            });

        });


        function hideTitle(itemTitle, input) {
            if (!itemTitle) return;
            if ($.trim(input.val()) == '' && input.get(0) != document.activeElement) {
                itemTitle.css("visibility", "visible");
            } else itemTitle.css("visibility", "hidden");
        }

        function makeActiveState(item, input, activeState, itemTitle) {
            
            activeState.find(".item-title").css({ visibility: "hidden" });

            item.find(".input-control").attr("readonly", "readonly");

            item.find("input, textarea").bind("focus", function () {
                item.css("display", "none");
                activeState.css("display", "block");
                activeState.find("input, textarea").focus();
            });

            activeState.find("input, textarea").bind("focusout", function () {
                activeState.css("display", "none");
                item.css("display", "block");
                input.val(activeState.find(".input-control").val());
                hideTitle(itemTitle, input);
            });
        }
    };
} (jQuery));
