/*! Copyright (c) 2014 Esnek Yazilim (http://esnekyazilim.com)
*/

(function ($) {

    $.fn.EsnekSlider = function (options) {
        // This is the easiest way to have default options.
        var settings = $.extend({
            // These are the defaults.
            rows: 1,
            cols: 1,
            autostart: false,
            sliderinterval: 5,
            onSeek: null,
            onBeforeSeek: null,
        }, options);

        this.each(function () {
        
            var part = $(this);

            var centerviewport = false;

            if(part.data("mobilize")) {

                var windw = $(window).width();

                part.find(".image-container img").css({ position: 'absolute', top: 0, left: 0 });

                part.data("processZones")(part.find(".zone").children(".viewport .zone"), "loadmobileproperties");

                var slidercontainer = part;

                var sliderw = part.parent().width();
               
                if (sliderw > windw) {
                    if(settings.cols > 1) {
                        var itemw = part.find(".viewport .item").first().width();
                        var size = settings.cols * settings.rows;
                        while(settings.cols > 1 && sliderw > windw) {
                            settings.cols --;
                            var newsize = 0;
                            while (newsize < size) {
                                settings.rows++;
                                newsize = settings.cols * settings.rows;
                            }
                            sliderw -= itemw;
                        }
                        centerviewport = true;
                    }
                }

                if (sliderw > windw) {                    
                    
                    var ratio = windw / sliderw;

                    var innerzones = slidercontainer.find(".zone");

                    innerzones.css("background-size", "contain");

                    slidercontainer.width(windw);

                    innerzones.each(function () {

                        var innerzone = $(this);

                        var tester = null;
                        var placeholder = null;
                        if(!innerzone.is(":visible")){                         
                            placeholder = window.getPlaceHolder();
                            placeholder.insertBefore(innerzone);
                            tester = window.getTester();
                            tester.append(innerzone);                            
                        }

                        var izw = parseFloat(this.style.width);
                        if (isNaN(izw)) izw = innerzone.width();

                        var elh = innerzone.height();

                        innerzone.width(parseInt(izw * ratio));

                        var mr = parseFloat(innerzone.css("margin-right"));
                        if (isNaN(mr)) mr = 0;
                        var ml = parseFloat(innerzone.css("margin-left"));
                        if (isNaN(ml)) ml = 0;
                        var mt = parseFloat(innerzone.css("margin-top"));
                        if (isNaN(mt)) mt = 0;
                        var mb = parseFloat(innerzone.css("margin-bottom"));
                        if (isNaN(mb)) mb = 0;

                        var izpr = parseFloat(innerzone.get(0).style.right);
                        var izpl = parseFloat(innerzone.get(0).style.left);
                        var izpt = parseFloat(innerzone.get(0).style.top);
                        var izpb = parseFloat(innerzone.get(0).style.bottom);

                        var minH = parseFloat(innerzone.css("min-height"));
                        if (isNaN(minH)) minH = 0;

                        innerzone.css({ minHeight: (minH * ratio), height: (elh * ratio), marginLeft: (ml * ratio), marginRight: (mr * ratio), marginTop: (mt * ratio), marginBottom: (mb * ratio) });

                        if (!isNaN(izpr)) innerzone.css({ right: (izpr * ratio) });
                        if (!isNaN(izpl)) innerzone.css({ left: (izpl * ratio) });
                        if (!isNaN(izpt)) innerzone.css({ top: (izpt * ratio) });
                        if (!isNaN(izpb)) innerzone.css({ bottom: (izpb * ratio) });
                       
                        if(tester != null){
                            innerzone.insertAfter(placeholder);
                            placeholder.detach();
                        }

                        /*if (innerzone.data("mob-font-size")) {
                            var fontSize = parseFloat(innerzone.data("mob-font-size"));                            
                            var hastext = part.data("getTextNodesIn")(innerzone).parent();
                            hastext.parentsUntil(innerzone).andSelf().css({ fontSize: fontSize });
                        }
                        if (innerzone.data("mob-line-height")) {
                            var lineHeight = parseFloat(innerzone.data("mob-line-height"));
                            var hastext = part.data("getTextNodesIn")(innerzone).parent();
                            hastext.parentsUntil(innerzone).andSelf().css({ lineHeight: lineHeight + "px" });
                        }*/

                    });

                    var visibleimage = slidercontainer.find(".viewport .image-container img").first();

                    function applyOverrideClasses(){
                        part.find("*").each(function(){
                            var overrideclass = $(this).data("overrideclass");
                            if(overrideclass) $(this).addClass(overrideclass);
                        });
                    }

                    function setImageDimensions(){

                         slidercontainer.find("img").each(function () {
                         
                            mobctr++;

                            var el = $(this);
                    
                            el.data("overrideclass", "override" + mobctr);

                            var elw = visibleimage.width();

                            //var elh = visibleimage.height();
                            var mr = parseFloat(visibleimage.css("margin-right"));
                            if (isNaN(mr)) mr = 0;
                            var ml = parseFloat(visibleimage.css("margin-left"));
                            if (isNaN(ml)) ml = 0;

                            var width = 'width:' + (elw * ratio).toFixed(0) + 'px !important;';
                            //var width = 'width:' + elw + 'px !important;';
                            var marginLeft = 'margin-left:' + (ml * ratio) + 'px !important;';
                            var marginRight = 'margin-right:' + (mr * ratio) + 'px !important;';
                            /*var height = elh ? 'height:' + (elh * ratio) + 'px !important;' : '';
                            if (el.is("img")) height = 'height:auto !important;';
                            var minheight = elh ? 'min-height:' + (elh * ratio) + 'px !important;' : '';
                            if (el.is("img")) minheight = 'min-height:0px !important;';*/
                            var height = 'height:auto !important;';
                            var minheight = 'min-height:0px !important;';
                            //addNewStyle(".override" + mobctr + ' {' + width + height + minheight + marginLeft + marginRight + '}');
                            part.data("addNewStyle")(".override" + mobctr + ' {' + width + height + minheight + marginLeft + marginRight + '}');

                        });

                    }
                    var imgloadedctr = 0;
                    var imgloaded = setInterval(function(){
                        if(visibleimage.width() > 30 || imgloadedctr > 50) {                    
                            clearInterval(imgloaded);
                            setImageDimensions();
                            applyOverrideClasses();
                        } else imgloadedctr++;                        

                    }, 100);
                }

                part.data("checkWidth")(part.find(".zone:not(:has(.zone))"));
            }

            var slider = part.find(".slider");
            var items = slider.find(".item");
            items.removeClass("clft");
            var rows = settings.rows;
            var cols = settings.cols;
            
            items.find(".image-container img").css({ position: 'absolute', top: 0, left: 0 });
           
            var templateW = slider.width();
            var templateRect = slider.get(0).getBoundingClientRect();

            var navis = part.find(".navi");
            var navi = navis.first();
            var templateNaviRect = navi.size() > 0 ? templateNaviRect = navi.get(0).getBoundingClientRect() : null;
            var naviHasNext = navi.find(".next").size() > 0;
            var naviHasPrev = navi.find(".prev").size() > 0;

            var nextbtn = slider.find(".next");
            var prevbtn = slider.find(".prev");

            var templateNextRect = nextbtn.size() > 0 ? templateNextRect = nextbtn.get(0).getBoundingClientRect() : null;
            var templatePrevRect = prevbtn.size() > 0 ? templatePrevRect = prevbtn.get(0).getBoundingClientRect() : null;

            var minWidth = ((cols <= 1) || (part.width() < templateW)) ? templateW : '100%';

            slider.css({ marginRight: '', marginLeft: '', marginTop: '', marginBottom: '', width: minWidth, minHeight: 0 });

            var sliderMask = slider.find(".slider-mask");

            var slide;
            var row;
            items.each(function (ind) {
                if (ind == 0 || ind % (rows * cols) == 0) {
                    slide = $('<div class="slide"></div>');
                    slider.append(slide);
                }

                if (ind == 0 || ind % cols == 0) {
                    row = $('<div class="row"></div>');
                    slide.append(row);
                }

                row.append(this);
            });
            
            var slides = slider.find(".slide");
            slides.addClass("hidden");

            var getTextNodesIn = function (el) {
                return $(el).find(":not(iframe, a)").andSelf().contents().filter(function () {
                    return this.nodeType == 3;
                });
            };

            slider.find("a.link").each(function () {
                var link = $(this);
                var parent = link.parent();
                if (parent.is(".image-container, .link")) return;
                if (parent.find("a:not(.link)").size() == 0) {
                    getTextNodesIn(parent).add(parent.find("img")).each(function () {
                        var el = $(this);
                        if ($.trim(el.text())) {
                            var wrapper = $('<span style="position:relative"></span>');
                            wrapper.insertBefore(this);
                            wrapper.append(this);
                            var cloned = link.clone();
                            wrapper.append(cloned);
                            cloned.css({ height: wrapper.height() });
                        } else if (el.is("img")) {
                            el.css({ cursor: 'pointer' });
                            el.click(function () { window.location.href = link.attr("href"); });
                        }
                    });
                }
                link.removeClass("link").css({ display: 'none' });

            });

            var slidecount = slides.size();
            var current = 0;
            var autoInterval;
            var stop = false;
            var animating = false;

            var vpML = parseFloat(items.css("margin-left"));
            var vpMR = parseFloat(items.css("margin-right"));

            var itemsW = items.width();

            var vpMT = items.css("margin-top");
            var vpMB = items.css("margin-bottom");
            var vpH = Math.max.apply(null, items.map(function () { return $(this).height(); }).get());

            items.each(function () {
                var itm = $(this);
                itm.data("oMinH", itm.css("min-height"));
                itm.css({ display: 'block', marginRight: '', marginLeft: '', marginTop: '', marginBottom: '', minHeight: 0 });
            });
            
            var viewport = slider.find(".viewport");
            if (viewport.size() == 0) {
                viewport = $('<div class="viewport"></div>');
                slider.append(viewport);
            }
            viewport.css({ float: 'left', marginLeft: vpML, marginRight: vpMR, minHeight: 1 });
           
            var onright = viewport.nextUntil(".clft", ".zone");
            var onleft = viewport.prevUntil(".clft", ".zone");

            var nextfirst = onright.first();
            var nextlast = onright.last();
            var prevfirst = onleft.first();

            var viewportRect = viewport.get(0).getBoundingClientRect();
            var sliderRect = slider.get(0).getBoundingClientRect();

            var leftmargin = 0;
            var rightmargin = 0;
            var leftpoint = 0;
            var rightpoint = 0;

            if (prevfirst.size() > 0) {
                prevfirstRect = prevfirst.get(0).getBoundingClientRect();
                leftmargin = viewportRect.left - prevfirstRect.right;
                leftpoint = prevfirstRect.right;
            }
            else {

                leftmargin = viewportRect.left - sliderRect.left;
                leftpoint = sliderRect.left;
            }

            var correctedleft = false;

            if (nextfirst.size() > 0) {
                correctedleft = true;
                nextfirstRect = nextfirst.get(0).getBoundingClientRect();
                rightmargin = nextfirstRect.left - viewportRect.right;
                rightpoint = nextfirstRect.left;
            }
            else {
                rightmargin = sliderRect.right - viewportRect.right;
                rightpoint = sliderRect.right;
            }
         
            var viewportmargin = Math.min(rightmargin, leftmargin);

            var gap = 0;

            if (nextlast.size() > 0) {
                gap = nextlast.get(0).getBoundingClientRect().right + parseFloat(nextlast.css("margin-right"));
                gap = sliderRect.right - gap;
            }

            vpML = vpMR = 0;
            var fromleft = 0;
            if (nextfirst.size() > 0) {
                nextfirst.css({ marginLeft: viewportmargin });
                fromleft = (sliderRect.right - (nextfirstRect.left - viewportmargin));
            }

            var fromright = 0;
            if (prevfirst.size() > 0) {
                prevfirst.css({ marginRight: viewportmargin });
                fromright = ((viewportmargin + prevfirstRect.right) - sliderRect.left);
            }

            var newwidth = sliderRect.width - (fromleft + fromright);

            var vpW = cols > 1 ? newwidth + gap : itemsW;

            slides.width(vpW);
            slider.find(".row").width(vpW);

            var itemRows = slides.find(".row");

            var maxTop; // = Math.max.apply(null, itemRows.find(".image-container").map(function () { return this.getBoundingClientRect().top; }).get());
            
            for (i = 0; i < rows; i++) {

                var rowsInLine = $();

                slides.each(function () {
                    rowsInLine = rowsInLine.add($(this).find(".row").eq(i));
                });

                var imagecontainers = rowsInLine.find(".image-container");

                maxTop = Math.max.apply(null, imagecontainers.map(function () { return this.getBoundingClientRect().top; }).get());

                imagecontainers.each(function () {
                    var imagecontainer = $(this);
                    var imagecontainerRect = this.getBoundingClientRect();
                    if (imagecontainerRect.top < maxTop) {
                        imagecontainer.css({ marginTop: "+=" + (maxTop - imagecontainerRect.top) + "px" });
                    }
                });
            }

            if (cols > 1) {

                var itemRows = slides.find(".row");
                var itemW = itemRows.find(".item").width();

                itemRows.each(function () {
                    var row = $(this);
                    var rowW = row.width();

                    var items = row.find(".item");

                    var margin = (rowW - (itemW * cols)) / (cols - 1);

                    var maxitemHeight = Math.max.apply(null, items.map(function () { return $(this).height(); }).get());

                    items.height(maxitemHeight);

                    var oMinH = parseFloat(items.first().data("oMinH")); //all the items supposed to have the same min-height so...
                    var marginBottom = oMinH - maxitemHeight;
                    if (marginBottom < 0) marginBottom = 0;

                    items.css({ marginRight: margin, marginLeft: 0, marginBottom: marginBottom });
                    items.last().css({ marginRight: 0 });

                });

                if (rows > 1) vpH = Math.max.apply(null, slides.map(function () { return $(this).height(); }).get());

            } else if (rows > 1) {
                vpH = Math.max.apply(null, slides.map(function () { return $(this).height(); }).get());
            }

            viewport.css({ position: 'relative', overflow: 'hidden', width: vpW, height: vpH, float: 'left', zIndex: 1, marginLeft: vpML, marginRight: vpMR, marginTop: vpMT, marginBottom: vpMB });
            
            var animationpanel = $('<div></div>');
            animationpanel.css({ position: 'absolute', width: vpW, height: vpH, top: 0, left: 0 });

            viewport.append(slides.eq(current).removeClass("hidden"));
            
            var navidata = null;

            if (navi.size() > 0) {

                navis.css("visibility", "hidden");

                var navisource = navi.first();

                if (rows * cols < items.size()) {

                    navi = navisource.clone();
                    var naviRect = navisource.get(0).getBoundingClientRect();
                    sliderRect = slider.get(0).getBoundingClientRect();
                    navi.css({ visibility: 'visible', position: 'absolute', zIndex: 2, marginLeft: '0', marginRight: '0', marginTop: '0', marginBottom: '0', bottom: sliderRect.bottom - naviRect.bottom, left: naviRect.left - sliderRect.left, width: '', zIndex: 501 });
                    slider.append(navi);

                    navidata = {};
                    navidata.naviRect = navi.get(0).getBoundingClientRect();
                    navidata.templateNaviRect = templateNaviRect;

                    navidata.leftdist = templateNaviRect.left - templateRect.left;
                    navidata.rightdist = templateRect.right - templateNaviRect.right;

                    var naviItem = navi.find(".navi-item");
                    var naviItemActive = navi.find(".navi-item-active");
                    naviItemActive.css({ display: 'none' });

                    var marginBetween = 0;
                    if (naviItem.nextAll(".zone").first().get(0) == naviItemActive.get(0)) {
                        marginBetween = parseFloat(naviItem.css("margin-right")) + parseFloat(naviItemActive.css("margin-left"));
                        naviItem.add(naviItemActive).css({ marginLeft: '', marginRight: '' });
                    } else if (naviItemActive.nextAll(".zone").first().get(0) == naviItem.get(0)) {
                        marginBetween = parseFloat(naviItem.css("margin-left")) + parseFloat(naviItemActive.css("margin-right"));
                        naviItem.add(naviItemActive).css({ marginLeft: '', marginRight: '' });
                    }

                    var naviItemContainer = $('<div class="navi-item-container"></div>');
                    naviItemContainer.css({ marginRight: marginBetween, float: 'left' });
                    naviItemContainer.append(naviItem, naviItemActive);

                    navi.children(':not(.next, .prev, .navi-items-wrapper)').remove();

                    var naviItemsWrapper = navi.find(".navi-items-wrapper");
                    var itemsContainer = naviItemsWrapper.size() > 0 ? naviItemsWrapper : navi;

                    for (var i = 0; i < slidecount; i++) {

                        var newNaviItem = naviItemContainer.clone();
                        newNaviItem.addClass("item-" + i);
                        newNaviItem.data("slide-index", i);
                        newNaviItem.find(".navi-item").find("*:not(:has(*)):not(.converted-zone)").first().text(i + 1);
                        newNaviItem.find(".navi-item-active").find("*:not(:has(*)):not(.converted-zone)").first().text(i + 1);
                        itemsContainer.append(newNaviItem);
                        if (i == 0) {
                            newNaviItem.find(".navi-item").css({ display: 'none' });
                            newNaviItem.find(".navi-item-active").css({ display: 'block' });
                            newNaviItem.addClass("active");
                        }
                        newNaviItem.click(function () {
                            var slideIndex = $(this).data("slide-index");
                            moveSlide(slideIndex < current ? "toRight" : "toLeft", slideIndex);

                        });
                    }

                    navi.find(".navi-item-container:last").css({ marginRight: 0 });
                    navi.find(".navi-item-container:first").css({ marginLeft: 0 });
                }
            }

            if (sliderMask.size() > 0) {
                var masksource = sliderMask.first().clone();
                sliderMask.css({ background: '' });
                var maskRect = sliderMask.first().get(0).getBoundingClientRect();
                sliderRect = slider.get(0).getBoundingClientRect();
                masksource.css({ visibility: 'visible', position: 'absolute', marginLeft: '0', marginRight: '0', marginTop: '0', marginBottom: '0', top: maskRect.top - sliderRect.top, left: maskRect.left - sliderRect.left });
                masksource.html('');
                slider.append(masksource);
            }

            function GetNext() {
                if (current + 1 < slidecount) {
                    current++;
                } else {
                    current = 0;
                }
                return slides.eq(current);
            }

            function GetPrev() {
                if (current - 1 >= 0) {
                    current--;
                } else {
                    current = slidecount - 1;
                }
                return slides.eq(current);
            }

            if (nextbtn.size() > 0) {
                var btnsource = nextbtn.first();
                nextbtn.css("visibility", "hidden");
                if (rows * cols < items.size()) {
                    if (!naviHasNext) {
                        nextbtn = btnsource.clone();
                        var nbtnRect = btnsource.get(0).getBoundingClientRect();
                        sliderRect = slider.get(0).getBoundingClientRect();
                        nextbtn.css({ visibility: 'visible', position: 'absolute', marginLeft: '0', marginRight: '0', marginTop: '0', marginBottom: '0', top: nbtnRect.top - sliderRect.top, right: sliderRect.right - nbtnRect.right, zIndex: 501 });
                        slider.append(nextbtn);
                    } else { nextbtn = navi.find(".next"); }
                    nextbtn.click(function () {
                        moveSlide("toLeft");
                        //moveSlide("toTop");
                    });
                }
            }

            if (prevbtn.size() > 0) {
                var btnsource = prevbtn.first();
                prevbtn.css("visibility", "hidden");
                if (rows * cols < items.size()) {
                    if (!naviHasPrev) {
                        prevbtn = btnsource.clone();
                        var pbtnRect = btnsource.get(0).getBoundingClientRect();
                        sliderRect = slider.get(0).getBoundingClientRect();
                        prevbtn.css({ visibility: 'visible', position: 'absolute', marginLeft: '0', marginRight: '0', marginTop: '0', marginBottom: '0', top: pbtnRect.top - sliderRect.top, left: pbtnRect.left - sliderRect.left, zIndex: 501 });
                        slider.append(prevbtn);
                    } else { prevbtn = navi.find(".prev"); }

                    prevbtn.click(function () {
                        moveSlide("toRight");
                        //moveSlide("toBottom");
                    });
                }
            }

            var arrowdata = null;

            if (nextbtn.size() > 0 && !naviHasNext && prevbtn.size() > 0 && !naviHasPrev && (rows * cols < items.size())) {
                arrowdata = {};
                arrowdata.prevRect = prevbtn.get(0).getBoundingClientRect();
                arrowdata.nextRect = nextbtn.get(0).getBoundingClientRect();
                arrowdata.templatePrevRect = templatePrevRect;
                arrowdata.templateNextRect = templateNextRect;

                arrowdata.leftdist = arrowdata.templatePrevRect.left - templateRect.left;
                arrowdata.rightdist = templateRect.right - arrowdata.templateNextRect.right;

                arrowdata.distbetween = arrowdata.nextRect.left - arrowdata.prevRect.right;
            }

            function repositionArrows() {

                if (!arrowdata || cols <= 1) return;

                var isdistributed = arrowdata.distbetween / templateRect.width > 1 / 2;

                var nextRect = nextbtn.get(0).getBoundingClientRect();

                if ((Math.abs(arrowdata.leftdist - arrowdata.rightdist) / (arrowdata.leftdist + arrowdata.rightdist)) < 1 / 5 && !isdistributed) {

                    sliderRect = slider.get(0).getBoundingClientRect();

                    var prevRect = prevbtn.get(0).getBoundingClientRect();

                    var blockwidth = nextRect.right - prevRect.left;

                    var newposition = (sliderRect.width - blockwidth) / 2;
                    nextbtn.css({ right: newposition });
                    prevbtn.css({ left: newposition });

                    /*var movement = (sliderRect.width - templateRect.width) / 2;
                    nextbtn.css({ right: "-=" + movement + "px" });
                    prevbtn.css({ left: "+=" + movement + "px" });*/


                } else if (isdistributed) {

                    if (!correctedleft) {
                        sliderRect = slider.get(0).getBoundingClientRect();
                        var movement = sliderRect.right - nextRect.right - arrowdata.rightdist;
                        nextbtn.css({ right: "-=" + movement + "px" });
                    }

                } else if (arrowdata.rightdist < arrowdata.leftdist) {

                    sliderRect = slider.get(0).getBoundingClientRect();
                    var movement = sliderRect.right - nextRect.right - arrowdata.rightdist;
                    nextbtn.css({ right: "-=" + movement + "px" });
                    prevbtn.css({ left: "+=" + movement + "px" });

                }
            }

            repositionArrows();

            function repositionNavi() {

                //if (!navidata || cols <= 1) return;
                if (!navidata) return;

                if ((Math.abs(navidata.leftdist - navidata.rightdist) / (navidata.leftdist + navidata.rightdist)) < 1 / 5) {

                    sliderRect = slider.get(0).getBoundingClientRect();

                    var naviRect = navi.get(0).getBoundingClientRect();

                    var blockwidth = naviRect.width;

                    var newposition = (sliderRect.width - blockwidth) / 2;
                    navi.css({ left: newposition });


                } else if (navidata.rightdist < navidata.leftdist) {

                    navi.css({ left: '', right: navidata.rightdist });

                }
            }

            repositionNavi();

            function moveSlide(movementDirection, slideIndex) {

                if (slideIndex == current) return;

                if (slidecount == 1) return;

                if (animating) return;

                animating = true;

                try {

                    var currentSlide = viewport.find(".slide");
                    var nextSlide;
                    if (slideIndex >= 0) {
                        nextSlide = slides.eq(slideIndex);
                        current = slideIndex;
                    }

                    animationpanel.insertBefore(currentSlide);

                    var animationCss = {};
                    var nextSlideAfterCss = { top: 0, left: 0 };
                    var animationAfterCss = { top: 0, left: 0 };

                    if (movementDirection == "toLeft") {
                        var itemMR = parseFloat(currentSlide.find(".item").first().css("margin-right"));
                        if (!nextSlide) nextSlide = GetNext();
                        nextSlide.css({ top: 0, left: vpW + itemMR });
                        animationCss.left = -(vpW + itemMR);
                    } else if (movementDirection == "toRight") {
                        var itemMR = parseFloat(currentSlide.find(".item").first().css("margin-right"));
                        if (!nextSlide) nextSlide = GetPrev();
                        nextSlide.css({ top: 0, left: -(vpW + itemMR) });
                        animationCss.left = vpW + itemMR;
                    }
                    else if (movementDirection == "toTop") {
                        if (!nextSlide) nextSlide = GetNext();
                        nextSlide.css({ top: vpH, left: 0 });
                        animationCss.top = -vpH;
                    } else if (movementDirection == "toBottom") {
                        if (!nextSlide) nextSlide = GetPrev();
                        nextSlide.css({ top: -vpH, left: 0 });
                        animationCss.top = vpH;
                    }

                    if (sliderMask.size() > 0) slider.find(".mask-link").detach();

                    nextSlide.removeClass("hidden");

                    animationpanel.append(nextSlide, currentSlide);

                    if (settings.onBeforeSeek != null) settings.onBeforeSeek();


                    /*if(sliderMask.size() > 0) {
                        currentSlide.find('[part-role="text"]').fadeOut("fast");
                    }*/

                    animationpanel.animate(animationCss, 400, "swing", function () {
                        nextSlide.insertAfter(animationpanel);
                        nextSlide.css(nextSlideAfterCss);
                        currentSlide.detach();
                        animationpanel.detach();
                        animationpanel.css(animationAfterCss);
                        updateNavigation();
                        animating = false;

                        if (sliderMask.size() > 0) setMaskLink(viewport.find(".link, .text"));

                        /*if(sliderMask.size() > 0) {
                            nextSlide.find('[part-role="text"]').fadeIn("fast");
                        }*/


                        if (settings.onSeek != null) {
                            settings.onSeek();
                        }

                    });

                } catch (ex) { animating = false; }

            }

            function updateNavigation() {
                var active = navi.find(".active");
                active.removeClass("active");
                active.find(".navi-item").css({ display: 'block' });
                active.find(".navi-item-active").css({ display: 'none' });
                active = navi.find(".item-" + current);
                active.addClass("active");
                active.find(".navi-item").css({ display: 'none' });
                active.find(".navi-item-active").css({ display: 'block' });
            }

            function setMaskLink(links) {
                links.each(function () {

                    var link = $(this);
                    var masklink = link.data("masklink");
                    if (!masklink) {
                        var linkRect = this.getBoundingClientRect();
                        sliderRect = slider.get(0).getBoundingClientRect();
                        masklink = link.clone(true);
                        masklink.css({ top: linkRect.top - sliderRect.top, left: linkRect.left - sliderRect.left, bottom: '', right: '', width: linkRect.width, height: linkRect.height });
                        masklink.addClass("mask-link");
                        link.css("display", "none");
                        link.data("masklink", masklink.get(0));
                        link.removeAttr("rel");
                    }
                    slider.append(masklink);

                });

            }

            if (sliderMask.size() > 0) setMaskLink(viewport.find(".link, .text"));

            if (settings.autostart == true) {

                autoInterval = setInterval(function () {

                    if (!stop) {
                        moveSlide("toLeft");
                    }

                }, settings.sliderinterval * 1000);
            }

            viewport.add(navi).add(prevbtn).add(nextbtn).hover(function () {

                stop = true;

            }, function () {

                stop = false;

            });

            /*items.find(".image-container").each(function () {
            var imagecontainer = $(this);
            var imgH = imagecontainer.find("img").height();
            imagecontainer.children("*:not(img)").css({ marginTop: "-=" + imgH + "px" });

            });*/

            if(centerviewport) {
                if(viewport.siblings().size() == 0){
                    var vpml = (viewport.parent().width() - viewport.width()) / 2;
                    var vpmr = vpml;                    
                    viewport.css({marginLeft:vpml, marginRight:vpmr});
                }
            }
            if(part.data("mobilize")) viewport.parentsUntil(".esnslider").height("auto");
            slider.css("visibility", "visible");
            viewport.addClass("viewport-ready");
        });
    };
} (jQuery));
