﻿window.PartTypeMappings = { slider: 'SliderWithZones', list: 'ListWithZonesV2', box: 'BoxWithZones', menu: 'MenuWithZones', form: 'CustomFormWithZones', texts: 'TextsWithZones', breadcrumbs: 'BreadcrumbsWithZones' }
window.PartTypeSelect = '<select class="parttype"><option value="0">---</option><option value="slider">Slider</option><option value="list">Liste</option><option value="menu">Menü</option><option value="box">Kutu</option><option value="form">Form</option><option value="texts">Bölümlenmiş İçerik</option><option value="breadcrumbs">Breadcrumbs</option></select>';

var sliderBase = function (extend) {

    var mappings =
        [ {
            title: "Sol Ok",
            type: "left-arrow",
            id: 101
        }, {
            title: "Sağ Ok",
            type: "right-arrow",
            id: 102
        }, {
            title: "Navigasyon Bloğu",
            type: "navigation-block",
            id: 103
        }, {
            title: "Navigasyon İmi",
            type: "navigation-item",
            id: 104,
            childof: 103
        }, {
            title: "Navigasyon Metni",
            type: "navigation-item-text",
            id: 105,
            childof:104
        }, {
            title: "Navigasyon Aktif İmi",
            type: "navigation-item-active",
            id: 106,
            childof: 103
        }, {
            title: "Navigasyon Aktif Metni",
            type: "navigation-item-active-text",
            id: 107,
            childof: 106
        }, {
            title: "Maske",
            type: "mask",
            id: 108
        }];

    var sort = true;

    $.each(extend, function (ind, el) {
        if (el.id === undefined) sort = false;
        mappings.push(el);
    });

    return sort ? mappings.sort(function (a, b) { return a.id > b.id }) : mappings;

};

window.PartToZoneConversionData = {

    slider: new sliderBase(
        [{
            title: "Slider",
            type: "slider",
            isrequired: true,
            ispartroot: true,
            id: 1
        }, {
            title: "Slider Başlığı",
            type: "text",
            property: "TitleHtml",            
            id: 2
        }, {
            title: "Slider Elemanı",
            type: "item",
            isrequired: true,
            id: 3
        }, {
            title: "Eleman Başlığı",
            type: "text",
            binding: "Title",
            id: 4,
            childof: 3
        }, {
            title: "Eleman Resmi",
            type: "image",
            binding: "ImageUrl",
            id: 5,
            childof: 3
        }, {
            title: "Eleman Metni",
            type: "text",
            binding: "Text",
            id: 6,
            childof: 3
        }, {
            title: "Detaylar Bloğu",
            type: "link",
            block: "details",
            binding: "ImageLink",
            id: 99,
            optional: true
        }, {
            title: "Detaylar",
            type: "text",
            block: "details",
            property: "DetailsButton",
            id: 100,
            childof: 99
        } ]
    ),

    list: new sliderBase(
        [{
            title: "Liste",
            type: "list",
            isrequired: true,
            ispartroot: true,
            id: 1
        }, {
            title: "Liste Başlığı",
            type: "text",
            property: "TitleHtml",
            id: 2
        }, {
            title: "Liste Elemanı",
            type: "item",
            isrequired: true,
            id: 3
        }, {
            title: "Eleman Başlığı",
            type: "text",
            binding: "ListTitle",
            id: 4,
            childof: 3
        }, {
            title: "Eleman Resmi",
            type: "image",
            binding: "ListImage",
            id: 5,
            childof: 3
        }, {
            title: "Eleman Metni",
            type: "text",
            binding: "ListText",
            id: 6,
            childof: 3
        }, {
            title: "Eklenme Tarihi",
            type: "date",
            binding: "DateAdded",
            id: 7,
            childof: 3
        }, {
            title: "Detaylar Bloğu",
            type: "link",
            block: "details",
            binding: "Path",
            id: 99,
            optional: true
        }, {
            title: "Detaylar",
            type: "text",
            block: "details",
            property: "DetailsButton",
            id: 100,
            childof: 99
        }]
    ),

    menu: 
        [{
            title: "Menü",
            type: "menu",
            isrequired: true,
            ispartroot: true,
            id:1
        }, {
            title: "1. Düzey",
            isrequired: true,
            type: "level-0",
            id: 2
        }, {
            title: "1. Düzey Eleman",
            isrequired: true,
            type: "item-0",
            id: 3,
            childof: 2
        }, {
            title: "1. Düzey Link",
            isrequired: true,
            type: "link",
            id: 4,
            childof: 3
        }, {
            title: "1. Düzey Metin",
            isrequired: true,
            type: "text",
            binding: "Title",
            id: 5,
            childof: 4
        }, {
            title: "1. Düzey Aktif Eleman",
            isrequired: true,
            type: "item-0-active",
            id: 7,
            childof: 2
        }, {
            title: "1. Düzey Aktif Link",
            isrequired: true,
            type: "link",
            id: 8,
            childof: 7
        }, {
            title: "1. Düzey Aktif Metin",
            isrequired: true,
            type: "text",
            binding: "Title",
            id: 9,
            childof: 8
        },  {
            title: "2. Düzey",
            type: "level-1",
            id: 201,
            notchildof: 2,
            dependson: [5,9]
        }, {
            title: "2. Düzey Eleman",
            type: "item-1",
            id: 202,
            childof: 201
        }, {
            title: "2. Düzey Link",
            type: "link",
            id: 203,
            childof: 202
        }, {
            title: "2. Düzey Metin",
            type: "text",
            binding: "Title",
            id: 204,
            childof: 203
        }, {
            title: "2. Düzey Aktif Eleman",
            type: "item-1-active",
            id: 205,
            childof: 201
        }, {
            title: "2. Düzey Aktif Link",
            type: "link",
            id: 206,
            childof: 205
        }, {
            title: "2. Düzey Aktif Metin",
            type: "text",
            binding: "Title",
            id: 207,
            childof: 206
        }],

    box:
        [{
            title: "Kutu",
            type: "box",            
            isrequired: true,
            ispartroot: true,
            id: 1
        }, {
            title: "Başlık Bloğu",
            type: "link",
            block:"title",
            id: 2,
            optional: true
        }, {
            title: "Başlık",
            type: "text",
            block: "title",
            property:"TitleHtml",
            id: 3,
            childof: 2
        }, {
            title: "Resim",
            type: "image",
            property: "ImageUrl",
            id: 4
        }, {
            title: "Metin",
            type: "text",
            property:"Text",
            id: 5
        }, {
            title: "Detaylar Bloğu",
            type: "link",
            block: "details",
            id: 6,
            optional: true
        }, {
            title: "Detaylar",
            type: "text",
            block: "details",
            property: "DetailsButton",
            id: 7,
            childof: 6
        }],

    form:
        [{
            title: "Form",
            type: "form",
            isrequired: true,
            ispartroot: true,
            id: 1
        }, {
            title: "Başlık Bloğu",
            type: "block",
            block: "title",
            id: 2,
            optional: true
        }, {
            title: "Başlık",
            type: "text",
            block: "title",
            property: "TitleHtml",
            id: 3,
            childof: 2
        }, {
            title: "Sonuç Mesajı",
            type: "result-message",
            id: 3.1
        }, {
            title: "Form Alanları",
            type: "form-fields",
            id: 4
        }, {
            title: "Metin Alanı Şablonu",
            type: "text-input-template",
            id: 5,
            childof: 4
        }, {
            title: "Metin Alanı",
            type: "field-item",
            id: 6,
            childof: 5
        }, {
            title: "Alan Başlığı",
            type: "input-title",
            binding: "InputTitle",
            id: 7,
            childof: 6
        }, {
            title: "Metin Girişi",
            type: "input-control",
            id: 8,
            childof: 6
        }, {
            title: "Hata Mesajı",
            type: "required-message",
            property: "FormRequired",
            id: 8.1,
            childof: 6
        }, {
            title: "Aktif Metin Alanı",
            type: "field-item-active",
            id: 9,
            childof: 5
        }, {
            title: "Alan Başlığı",
            type: "input-title",
            binding: "InputTitle",
            id: 10,
            childof: 9
        }, {
            title: "Metin Girişi",
            type: "input-control",
            id: 11,
            childof: 9
        }, {
            title: "Hata Mesajı",
            type: "required-message",
            property: "FormRequired",
            id: 11.1,
            childof: 9
        }, {
            title: "Çok Satırlı Metin Alanı Şablonu",
            type: "textarea-template",
            id: 12,
            childof: 4
        }, {
            title: "Metin Alanı",
            type: "field-item",
            id: 13,
            childof: 12
        }, {
            title: "Alan Başlığı",
            type: "input-title",
            binding: "InputTitle",
            id: 14,
            childof: 13
        }, {
            title: "Metin Girişi",
            type: "input-control",
            id: 15,
            childof: 13
        }, {
            title: "Hata Mesajı",
            type: "required-message",
            property: "FormRequired",
            id: 15.1,
            childof: 13
        }, {
            title: "Aktif Metin Alanı",
            type: "field-item-active",
            id: 16,
            childof: 12
        }, {
            title: "Alan Başlığı",
            type: "input-title",
            binding: "InputTitle",
            id: 17,
            childof: 16
        }, {
            title: "Metin Girişi",
            type: "input-control",
            id: 18,
            childof: 16
        }, {
            title: "Hata Mesajı",
            type: "required-message",
            property: "FormRequired",
            id: 18.1,
            childof: 16
        }, {
            title: "Buton Şablonu",
            type: "button-template",
            id: 19
        }, {
            title: "Gönder Butonu",
            type: "button-item",
            id: 20,
            childof: 19
        }, {
            title: "Buton",
            type: "button",
            id: 21,
            childof: 20
        }, {
            title: "Buton Metni",
            type: "text",
            id: 22,
            childof: 21,
            property:"FormSend"
        }, {
            title: "Aktif Gönder Butonu",
            type: "button-item-active",
            id: 23,
            childof: 19
        }, {
            title: "Buton",
            type: "button",
            id: 24,
            childof: 23
        }, {
            title: "Buton Metni",
            type: "text",
            id: 25,
            childof: 24,
            property: "FormSend"
        }]

}

window.esnMouseOut = false;

$(document).ready(function () {

    if ($("form").is(".preview")) {

        $(window).mouseenter(function () {

            if (window.esnMouseOut == false) return;

            window.esnMouseOut = false;

            $.get("/edit/GenericHandler.ashx?Request=GetVersionID", function (data) {

                if (data && data != window.esnSiteVersionID) {
                    window.location.reload();
                }

            });

        });

        $(window).mouseleave(function () {

            window.esnMouseOut = true;

        });

        $(".operations .btn-import").click(function () {

            $.get("/edit/GenericHandler.ashx?Request=ImportPage", function (data) {
                if (data) {
                    window.location.href = data;
                }
            });
        });

        var isinprocess = false;

        $(".operations .tohtml").click(function () {

            if (isinprocess) return;

            var selectedPages = $("#admin_panel .treeview").find(".checkbox.checked").siblings(".OneColumn, .Homepage, .Redirect").siblings(".treeview_page");

            if (selectedPages.size() == 0) {

                alert("Lütfen en az bir sayfa seçiniz.");
                return;
            }

            if (!confirm("Seçtiğiniz sayfalar için dönüştürme işlemini onaylamış olacaksınız. Bu durumda reddetme hakkınız olmayacak.\nDevam etmek istiyor musunuz?")) return;

            var exitfunc = false;

            var pages = [];

            selectedPages.each(function () {

                var page = $(this);

                var leafstatus = (page.parent().find("ul li a.treeview_page").size() > 0) ? "o" : "c";

                pages.push(page.attr("href") + "$" + leafstatus);

                /*if (page.siblings(".published").size() == 0) {
                alert("Bu işlem için seçtiğiniz sayfaların yayımlanmış olması gerekiyor. Lütfen önce seçili sayfaları yayımlayınız.");
                exitfunc = true;
                return false;
                }*/

            });

            if (exitfunc) return;

            var postdata = "pages=" + pages.join();

            isinprocess = true;

            try {
                $.post("/ExportToHtmlHandler.ashx", postdata, function (data) {

                    isinprocess = false;

                    if (data) {
                        if (data == "ERROR") alert("HATA");
                        else
                            window.location.href = data;
                    }
                });
            } catch (ex) { isinprocess = false; }

        });

        $(".operations .toemail").click(function () {

            if (!confirm("Dönüştürme işlemini onaylamış olacaksınız. Bu durumda reddetme hakkınız olmayacak.\nDevam etmek istiyor musunuz?")) return;

            $.get("/ConvertToEmailHandler.ashx?page=" + encodeURIComponent(window.location.pathname));

            if ($('#upload_panel .fileProcessesInfoPanel').size() > 0) { alert('Geçersiz sayfa tipi.'); return; };

            var site = $(".site");

            site.find(".zone").each(function () {
                $(this).attr("obottom", this.getBoundingClientRect().bottom);
            });

            var emailcontent = site.clone();

            emailcontent.find("#editor_tool_bar").remove();

            var zones = emailcontent.find(".zone");

            var exitfunc = false;

            zones.each(function () {

                var zone = $(this);
                var zoneMT = parseFloat(zone.css("margin-top"));
                var zoneML = parseFloat(zone.css("margin-left"));

                if (zoneMT < 0 || zoneML < 0) {

                    if (!confirm('Bu sayfada sınır değeri negatif olan alanlar var.\nBu durum bir alanın kendisini içeren alının dışına taşmasından kaynaklanır.\nBu da oluşturulacak e-mailde görünüm farklılığına neden olacaktır.\nİşleme devam etmeden önce, alanları, kendisini içeren alanın dışına taşmayacak şekilde düzenlemeniz önerilir.\nİşleme devam etmek istiyor musunuz?')) {
                        //if (confirm('Bu alanlar işaretlensin mi?')) {
                        $(".site").find(".zone").each(function () {

                            zone = $(this);
                            zoneMT = parseFloat(zone.css("margin-top"));
                            zoneML = parseFloat(zone.css("margin-left"));

                            if (zoneMT < 0 || zoneML < 0) {
                                zone.children(".zone-rect").css("outline", "2px dashed #ff0000");
                                zone.click(function () {
                                    $(this).children(".zone-rect").css("outline", "");
                                });
                            }
                        });
                        //}
                        exitfunc = true; return false;
                    }
                    else return false;
                }

            });

            if (exitfunc) return;

            if (!(navigator.userAgent.indexOf('Chrome') > -1)) {
                alert('Bu özelliği en başarılı şekilde kullanmak için tarayıcı olarak CHROME ve email düzenleyicisi olarak da OUTLOOK.COM tercih etmelisiniz.');
            }

            if ($("#invisiblecontainer").size() == 0) {
                $("head").append('<style id="invisiblecontainer">.invisiblecontainer{position:absolute; top:0; left:0; visibility:hidden}.invisiblecontainer *{visibility:hidden ! important}</style>');
            }

            var invisiblecontainer = $('<div class="invisiblecontainer"></div>');

            invisiblecontainer.append(emailcontent);

            $("body").append(invisiblecontainer);

            var images = emailcontent.find("img");
            images.each(function () {

                var img = $(this);
                var src = img.attr("src");
                if (src && src.indexOf("http") != 0) {
                    src = "http://" + window.location.host + src;
                    img.attr("src", src);
                }

            });

            var elements = emailcontent.find(".part_content *").add(emailcontent);

            var fontfamilies = [];

            elements.each(function () {

                var element = $(this);

                var hastextcontent = false;

                element.contents().each(function () {

                    if (this.nodeType == 3 && !/\s/.test(this.nodeValue)) {
                        hastextcontent = true;
                        return false;
                    }

                });

                if (!hastextcontent) {

                    element.css({ margin: 0, padding: 0 });
                    return true;
                }

                var fontfamily = element.css("font-family").split(",")[0];

                fontfamily = $.trim(fontfamily);

                fontfamily = fontfamily.replace(/"/g, "'");

                if (fontfamily.split(" ").length == 1) fontfamily = fontfamily.replace(/'/g, '');

                if (fontfamilies.indexOf(fontfamily) < 0) {

                    fontfamilies.push(fontfamily);
                }

                /*var color = this.style.color;
                if (!color || color == "transparent" || color == "none" || color == "initial") color = null;
                else color = Esnek.Color.ColorToHex(color);

                this.style.color = color;*/

                element.css({
                    fontSize: element.css("font-size"),
                    fontFamily: fontfamily,
                    lineHeight: element.css("line-height"),
                    margin: 0,
                    color: element.css("color"),
                    padding: 0,
                    border: "none",
                    outline: "none"
                });

            });

            var websafefonts = ["Arial, Helvetica, sans-serif", "'Arial Black', Gadget, sans-serif", "'Comic Sans MS', cursive", "'Courier New', monospace", "Georgia, serif", "Impact, Charcoal, sans-serif", "'Lucida Console', Monaco, monospace", "'Lucida Sans Unicode', 'Lucida Grande', sans-serif", "'Palatino Linotype', 'Book Antiqua', Palatino, serif", "Tahoma, Geneva, sans-serif", "'Times New Roman', Times, serif", "'Trebuchet MS', sans-serif", "Verdana, Geneva, sans-serif", "'MS Sans Serif', Geneva, sans-serif", "'MS Serif', 'New York', serif"];

            function getWebSafeFonts() {

                var select = $('<select style="font-family:Arial; font-size:13px"></select>');
                $.each(websafefonts, function (ind, el) {

                    select.append('<option value="' + el + '">' + el.split(",")[0].replace(/'/g, '') + "</option>");

                });

                return select;

            }

            var overlay = $('<div class="dialog-overlay"></div>');
            overlay.css({ position: "absolute", top: 0, left: 0, width: $(document).width(), height: $(document).height(), zIndex: 30000, background: "#444444", opacity: 0.8 });
            $("body").append(overlay);
            var dialog = $('<div class="small-dialog" style="font-family:Arial; font-size:13px"></div>');
            dialog.css({ background: "#ffffff", position: "fixed", top: $(window).height() / 2, left: $(window).width() / 2, width: 300, height: 300, marginLeft: -160, marginTop: -160, zIndex: 30001, borderRadius: 8, padding: 20 });
            $("body").append(dialog);

            dialog.append('<p style="font-family:Arial; font-size:13px; font-weight:bold; padding:0 0 10px 5px">Font Eşleştir</p>');

            var mappingtable = $("<table></table>");
            dialog.append(mappingtable);

            $.each(fontfamilies, function (ind, el) {

                var newrow = $("<tr></tr>");

                var family = $('<td style="padding:5px; vertical-align:top"></td>');

                family.attr("alt", el);

                family.text(el.replace(/'/g, ''));

                mappingtable.append(newrow);
                newrow.append(family);
                var mappings = getWebSafeFonts();
                mappings.val(mappings.find('option[value^="' + el + '"]').val());

                var mfamily = $('<td style="padding:5px; vertical-align:top"></td>');
                newrow.append(mfamily);
                mfamily.append(mappings);

            });

            var btnarea = $('<div style="text-align:center"></div>');
            var okbtn = $('<a class="fancy" style="float:none; margin-top:20px">Tamam</a>');

            dialog.append(btnarea);
            btnarea.append(okbtn);

            okbtn.click(function () {

                var fontfamily;
                var mfamily;

                elements.each(function () {

                    var elm = $(this);

                    fontfamily = elm.css("font-family");
                    fontfamily = fontfamily.replace(/"/g, "'");
                    mfamily = mappingtable.find('td[alt="' + fontfamily + '"]').next().find("select").val();

                    elm.css("font-family", mfamily);

                    if (elm.is("a")) {
                        elm.css("text-decoration", elm.css("text-decoration"));
                        var href = elm.attr("href");
                        if (href && href.indexOf("http") != 0) {
                            href = "http://" + window.location.host + href;
                            elm.attr("href", href);
                        }
                    }
                });

                zones = emailcontent.find(".zone");

                zones.each(function () {

                    var zone = $(this);

                    zone.data("oHeight", zone.height());

                    var backgroundImage = zone.css("background-image");

                    var backgroundRepeat = zone.css("background-repeat");

                    if (backgroundImage && backgroundImage != "none") {
                        var img = $('<img />');
                        img.attr("src", backgroundImage.replace('url(', '').replace(')', '').replace(/"/g, ''));
                        zone.append(img);

                        if (zone.find(".zone").size() > 0) {
                            img.addClass("backgroundimage");
                            if (backgroundRepeat == "repeat-y") img.addClass("repeaty");
                            zone.addClass("needsbackgroundhack");
                        } else {
                            zone.css({ lineHeight: 0 });
                        }
                    }
                });

                function CreateTableLayout(zn) {

                    var children = zn.children(".zone");

                    if (children.size() > 0) {

                        var rows = [];

                        var clft = children.first();

                        while (true) {

                            var nextclft = clft.nextAll(".clft").first();
                            if (nextclft.size() > 0) {
                                rows.push(clft.nextUntil(nextclft.get(0), ".zone").add(clft));
                            } else {
                                rows.push(clft.nextAll(".zone").add(clft));
                                break;
                            }

                            clft = nextclft;
                        }

                        var rowcount = rows.length;
                        var diffbtm = null;

                        $.each(rows, function (ind, el) {
                            if (ind == rowcount - 1) {
                                var btm1 = zn.attr("obottom");
                                el.each(function (index) {
                                    var btm2 = $(this).attr("obottom");
                                    var newdiffbtm = btm1 - btm2;
                                    if (diffbtm == null) diffbtm = newdiffbtm;
                                    else if (diffbtm > newdiffbtm) diffbtm = newdiffbtm;
                                });
                            }

                            var table = $('<table cellpadding="0" cellspacing="0" border="0"></table>');
                            var tr = $("<tr></tr>");
                            var td;

                            table.append(tr);
                            zn.append(table);
                            table.css("width", zn.get(0).style.width);

                            el.each(function (index) {

                                var chld = $(this);

                                td = $('<td valign="top" align="left"></td>');

                                var paddingtable = $('<table class="removetable" cellpadding="0" cellspacing="0" border="0"></table>');
                                var paddingtr = $('<tr></tr>');
                                var paddingtd = $('<td class="removecell" valign="top" align="left"></td>');

                                tr.append(td);
                                td.append(paddingtable);

                                paddingtable.append(paddingtr);
                                paddingtr.append(paddingtd);

                                var innertable = $('<table cellpadding="0" cellspacing="0" border="0"></table>');
                                var innertr = $("<tr></tr>");

                                paddingtd.append(innertable);
                                innertable.append(innertr);

                                var bgcolor = chld.get(0).style.backgroundColor;
                                if (!bgcolor || bgcolor == "transparent" || bgcolor == "none" || bgcolor == "initial") bgcolor = null;
                                else {
                                    bgcolor = Esnek.Color.ColorToHex(bgcolor);
                                    chld.get(0).style.backgroundColor = bgcolor;
                                }

                                var innertd = $('<td valign="top" align="left"></td>');
                                if (bgcolor) innertd.attr("bgcolor", bgcolor);

                                var mR = parseFloat(chld.css("margin-right"));

                                if (el.size() > index + 1) {
                                    var next = el.eq(index + 1);
                                    var nextML = parseFloat(next.css("margin-left"));
                                    next.css({ marginLeft: nextML + mR });
                                    mR = 0;
                                }

                                paddingtd.css("padding-top", chld.css("margin-top"));
                                paddingtd.css("padding-left", chld.css("margin-left"));
                                paddingtd.css("padding-right", mR + "px");

                                innertd.css("width", this.style.width);

                                chld.css("margin-top", "");
                                chld.css("margin-left", "");
                                chld.css("margin-right", "");

                                if (chld.is(".needsbackgroundhack")) {

                                    var img = $(this).children(".backgroundimage").first();

                                    var outlookhack =
                                    '<!--[if gte mso 9]><v:rect xmlns:v="urn:schemas-microsoft-com:vml" fill="true" stroke="false"{0}><v:fill type="tile" src="{1}" color="none" /><v:textbox inset="0,0,0,0"><![endif]--><div class="wrpr outlookhackwrpr"></div><!--[if gte mso 9]></v:textbox></v:rect><![endif]-->'.
                                    format(!img.is(".repeaty") ? ' style="height:{0}px; width:{1}px;"'.format(img.height(), img.width()) : ' style="height:{0}px; width:{1}px;"'.format(chld.data("oHeight"), img.width()), img.attr("src"));

                                    var backgroundHack =

                                '<div{0} class="wrpr"><table cellpadding="0" cellspacing="0" border="0"><tr><td class="outlookhack" background="{1}"{2} valign="top" align="left">{3}</td></tr></table></div>'.format(
                                !img.is(".repeaty") ? ' style="height:{0}px;overflow:hidden"'.format(img.height()) : '', //' style="height:{0}px;"'.format(chld.data("oHeight")),
                                img.attr("src"),
                                ' height="{0}px" width="{1}px"'.format(chld.data("oHeight"), img.width()), //outlookhack);
                                chld.closest(".backgroundhack").size() == 0 ? outlookhack : '<div class="wrpr"></div>');


                                    backgroundHack = $(backgroundHack);
                                    img.remove();
                                    backgroundHack.find("div").first().append(this);
                                    if (chld.text() == "") chld.append('<span style="line-height:1px">&nbsp;</span>');
                                    chld = backgroundHack;
                                    chld.addClass("backgroundhack");
                                }

                                innertd.append(chld);
                                innertr.append(innertd);

                            });

                        });

                        var tablewrap = $('<table class="removetable" cellpadding="0" cellspacing="0" border="0"></table>');
                        zn.prepend(tablewrap);
                        var trwrap, tdwrap;
                        tablewrap.nextAll("table").each(function () {
                            trwrap = $('<tr></tr>');
                            tdwrap = $('<td class="removecell"></td>');
                            tablewrap.append(trwrap);
                            trwrap.append(tdwrap);
                            tdwrap.append(this);
                        });

                        if (diffbtm > 0) {
                            tdwrap.css("padding-bottom", parseInt(diffbtm));
                        }
                    }

                    children.each(function () {
                        CreateTableLayout($(this));
                    });

                }

                setTimeout(function () {

                    CreateTableLayout(emailcontent);

                    var zonestoclean = emailcontent.find(".zone").add(emailcontent);
                    zonestoclean.removeAttr("zoneid");
                    zonestoclean.removeAttr("zonecontainerid");
                    zonestoclean.removeAttr("inheritance");
                    zonestoclean.removeAttr("pageid");
                    zonestoclean.removeAttr("obottom");
                    zonestoclean.css({ background: '' });

                    var partstoclean = emailcontent.find(".part");
                    partstoclean.removeAttr("part-name");
                    partstoclean.removeAttr("id");

                    emailcontent.find(".BoxedImage a, .BoxedImage a img").css("display", "block");

                    emailcontent.find("div:not(.zone, .wrpr, .part, .part div)").remove();

                    partstoclean.find(".context_menu_toggler, .clear").remove();

                    emailcontent.find("*:not(.removetable, .removecell, .outlookhack, .outlookhackwrpr)").add(emailcontent).removeAttr("class");

                    emailcontent.find("div:not(.outlookhackwrpr)").each(function () {

                        var div = $(this);
                        div.contents().each(function () {
                            if (this.nodeType == 3 && $.trim(this.nodeValue.replace(/\u00a0/g, "x")).length == 0) $(this).remove();
                        });

                        if (!div.attr("style")) {

                            div.contents().each(function () {

                                $(this).insertBefore(div);

                            });

                            div.remove();
                        }

                    });

                    emailcontent.find("p, h1, h2, h3, h4, h5, h6").each(function () {
                        var div = $("<div></div>");
                        var tg = $(this);
                        tg.contents().each(function () {
                            div.append(this);
                        });
                        div.insertBefore(tg);
                        div.attr("style", tg.attr("style"));
                        tg.remove();
                    });

                    emailcontent.find("div, td, a").each(function () {
                        $(this).css("line-height", $(this).css("line-height"));
                    });

                    emailcontent.find("div:not(:has(div))").each(function () {
                        var div = $(this);

                        var ocurredlineheights = {}

                        div.find(":not(:has(*))").each(function () {

                            var elm = $(this);
                            var len = elm.text().length;
                            var lh = parseInt(elm.css("line-height"));
                            if (ocurredlineheights[lh]) ocurredlineheights[lh] += len;
                            else ocurredlineheights[lh] = len;

                        });

                        var maxlen = 0;
                        var selectedlh;

                        $.each(ocurredlineheights, function (key, el) {

                            if (ocurredlineheights[key] > maxlen) {
                                maxlen = ocurredlineheights[key];
                                selectedlh = key;
                            }

                        });

                        if (maxlen > 0) {
                            div.css("line-height", selectedlh + "px");
                            div.find("*").each(function () {

                                if (this.style.lineHeight) {
                                    $(this).css("line-height", selectedlh + "px");
                                }

                            });
                        }


                    });


                }, 2000);

                dialog.remove();
                overlay.remove();

                alert("Açılacak pencerede CTRL-A ve CTRL-C komutlarıyla e-mail içeriğini kopyalayınız ve ardından kullandığınız e-mail programının HTML düzenleyicisinde CTRL-V komutuyla yapıştırınız.\n\n ÖNEMLİ! ÖNEMLİ! ÖNEMLİ! Gönderdiğiniz e-maillerde resimlerin görünebilmesi için bu sayfayı silmemeniz gerekiyor!");

                var emailwindow = window.open("", "", "width={0}, height={1},scrollbars=1".format(800, 600));

                var setcontent = setInterval(function () {

                    if (emailcontent.find(".zone").size() == 0) {

                        clearInterval(setcontent);

                        var doc = emailwindow.document;
                        doc.write('<!doctype html><html><head></head><body style="position:relative"><div class="preview" style="border-bottom-left-radius:5px; border-bottom-right-radius:5px"><img style="margin:10px;" src="/esn/images/icons/fugue/magnifier.png" /></div><textarea readonly="true" style="width:780px; padding:10px; height:560px; border:none; margin:0; outline:none;"></textarea></body></html>');

                        $(emailwindow.document.body).css({ margin: "0" });

                        var textarea = $(emailwindow.document.body).find("textarea");

                        var preview = $(emailwindow.document.body).find(".preview");
                        preview.css({ position: "fixed", top: 0, right: 30, width: 36, height: 36, background: '#000000', opacity: 0.6, cursor: 'pointer' })

                        var clone = emailcontent.clone();

                        clone.find("*").add(clone).removeAttr("class");

                        var outlookhtml = clone.html().replace(/\<\!\-\-\[\if gte mso 9\]\>/g, '').replace(/\<\!\[endif\]\-\-\>/g, '');

                        outlookhtml = '<!--[if gte mso 9]>' + outlookhtml + '<![endif]-->';

                        emailcontent.find("*").each(function () {
                            var style = $(this).attr("style");
                            if (style) style += "mso-hide:all;";
                            else style = "mso-hide:all;";
                            $(this).attr("style", style);
                        });

                        emailcontent.find(".outlookhackwrpr").each(function () {

                            var outlookhackwrpr = $(this);
                            var outlookhack = outlookhackwrpr.closest(".outlookhack");
                            outlookhackwrpr.children().each(function () {
                                $(this).addClass("added");
                                outlookhack.append(this);
                            });

                            outlookhack.contents().each(function () {
                                if (!$(this).is(".added")) $(this).remove();
                            });

                            outlookhackwrpr.remove();
                        });

                        emailcontent.find(".removecell").each(function () {

                            var removecell = $(this);
                            var removetable = removecell.closest(".removetable");
                            var parentcell = removetable.parent();

                            if (parseInt(removecell.css("padding-top")))
                                parentcell.css("padding-top", removecell.css("padding-top"));
                            if (parseInt(removecell.css("padding-left")))
                                parentcell.css("padding-left", removecell.css("padding-left"));
                            if (parseInt(removecell.css("padding-right")))
                                parentcell.css("padding-right", removecell.css("padding-right"));

                            removecell.contents().each(function () {
                                parentcell.append(this);
                            });

                        });

                        $(".removetable").remove();

                        emailcontent.find("*").add(emailcontent).removeAttr("class");

                        /*emailcontent.find("img").each(function () {


                        });*/

                        var normalhtml = emailcontent.html();

                        var html = outlookhtml + normalhtml;
                        textarea.text(html);

                        $(emailwindow.document.body).focus();

                        textarea.focus();

                        var theinterval;
                        var ctr = 0;

                        function expandWindow() {
                            if (emailwindow.document.body.scrollWidth > emailwindow.document.body.clientWidth) {
                                emailwindow.resizeBy(1, 0);
                                ctr++;
                                if (ctr > 30) clearInterval(theinterval);
                            } else clearInterval(theinterval);
                        }

                        $(emailwindow.document).ready(function () {

                            if (emailwindow.document.body.scrollHeight + 2 > emailwindow.document.body.clientHeight) {

                                theinterval = setInterval(expandWindow, 50);
                            }
                        });

                        preview.click(function () {

                            var previewwindow = window.open("", "", "width={0}, height={1},scrollbars=1".format(emailcontent.width(), emailcontent.height()));

                            $(previewwindow.document.body).html('<p style="position:absolute; top:0; left:0">&nbsp;</p>' + html.replace(/mso\-hide\:all\;/g, '').replace(/style\=\"\"/g, ''));

                            $(previewwindow.document.body).css("margin", "0");

                            var theinterval;
                            var ctr = 0;

                            function expandPreviewWindow() {
                                if (previewwindow.document.body.scrollWidth > previewwindow.document.body.clientWidth) {
                                    previewwindow.resizeBy(1, 0);
                                    ctr++;
                                    if (ctr > 30) clearInterval(theinterval);
                                } else clearInterval(theinterval);
                            }

                            $(previewwindow.document).ready(function () {

                                if (previewwindow.document.body.scrollHeight + 2 > previewwindow.document.body.clientHeight) {

                                    theinterval = setInterval(expandPreviewWindow, 50);
                                }
                            });

                        });

                        invisiblecontainer.remove();
                    }

                }, 100);

            });
        });

        $(".operations .toserver").click(function () {

            if (isinprocess) return;

            var selectedPages = $("#admin_panel .treeview").find(".checkbox.checked").siblings(".OneColumn, .Homepage, .Redirect").siblings(".treeview_page");

            if (selectedPages.size() == 0) {

                alert("Lütfen en az bir sayfa seçiniz.");
                return;
            }

            if (!confirm("Seçtiğiniz sayfalar için dönüştürme işlemini onaylamış olacaksınız. Bu durumda reddetme hakkınız olmayacak.\nDevam etmek istiyor musunuz?")) return;

            var pages = [];

            selectedPages.each(function () {

                var page = $(this);

                var leafstatus = (page.parent().find("ul li a.treeview_page").size() > 0) ? "o" : "c";

                pages.push(page.attr("href") + "$" + leafstatus);

            });

            var postdata = "pages=" + pages.join();

            isinprocess = true;

            var pagesdata = "pages=" + pages.join();
            var overlay = $('<div class="dialog-overlay"></div>');
            overlay.css({ position: "absolute", top: 0, left: 0, width: $(document).width(), height: $(document).height(), zIndex: 30000, background: "#444444", opacity: 0.6 });
            $("body").append(overlay);
            var dialog = $('<div class="small-dialog" style="font-family:Arial; font-size:13px"></div>');
            dialog.css({ background: "#ffffff", position: "fixed", top: $(window).height() / 2, left: $(window).width() / 2, width: 300, height: 230, marginLeft: -160, marginTop: -160, zIndex: 30001, borderRadius: 8, padding: 20 });
            $("body").append(dialog);
            var dialogContent = $('<div class="dialog-content"></div>');
            dialog.append(dialogContent);

            dialogContent.append('<p class="dialog-title">Ftp Bilgileri</p>');

            var formdata = $.cookie('ifdt');
            if (formdata) eval('formdata = ' + formdata + ';');

            var inputfield = $('<div class="input-field"><span class="title"></span></div>');
            dialogContent.append(inputfield);
            inputfield.find(".title").text("Ftp Sunucusu : ");
            var inputHost = $('<input class="input" type="text" />');
            inputfield.append(inputHost);
            if (formdata && formdata.v1) inputHost.val(formdata.v1);

            inputfield = inputfield.clone();
            inputfield.find(".input").remove();
            dialogContent.append(inputfield);
            inputfield.find(".title").text("Ftp Kullanıcısı : ");
            var inputUser = $('<input class="input" type="text" />');
            inputfield.append(inputUser);
            if (formdata && formdata.v2) inputUser.val(formdata.v2);

            inputfield = inputfield.clone();
            inputfield.find(".input").remove();
            dialogContent.append(inputfield);
            inputfield.find(".title").text("Ftp Şifre : ");
            var inputPass = $('<input class="input" type="password" />');
            inputfield.append(inputPass);

            inputfield = inputfield.clone();
            inputfield.find(".input").remove();
            dialogContent.append(inputfield);
            inputfield.find(".title").text("Ana Dizin : ");
            var inputRoot = $('<input class="input" type="text" />');
            inputfield.append(inputRoot);
            if (formdata && formdata.v4) inputRoot.val(formdata.v4);

            var progressField = $('<div class="progress" style="display:none"></div>');
            var progresstitle = $('<p class="progress-title">İşlem Devam Ediyor...</p>');
            var loading = $('<div class="loading"><img src="/esn/images/loading.gif" /></div>');
            var info = $('<div class="info"></div>');
            var newwindow = $('<div class="newwindow"><a href="{0}" target="_blank">Yeni pencere açmak için buraya tıklayın.</a></div>'.format(window.location.href));
            var continuebtn = $('<div class="continuebtn"><a class="fancy">Tamam</a></div>');

            dialog.prepend(progressField);
            progressField.append(progresstitle);
            progressField.append(loading);
            progressField.append(info);
            progressField.append(newwindow);
            progressField.append(continuebtn);

            continuebtn.find(".fancy").click(function () {

                progressField.hide();
                dialogContent.show();
                btnarea.show();

            });

            var btnarea = $('<div class="dialog-buttons" style="text-align:center"></div>');
            var okbtn = $('<a class="fancy">Tamam</a>');
            var cancelbtn = $('<a class="fancy">İptal</a>');
            dialog.append(btnarea);
            btnarea.append(okbtn);
            btnarea.append('&nbsp;&nbsp;&nbsp;');
            btnarea.append(cancelbtn);

            okbtn.click(function () {

                var host = inputHost.val();
                var user = inputUser.val();
                var pass = inputPass.val();
                var root = inputRoot.val();

                if (!host || !user || !pass) {
                    alert('Sunucu, kullanıcı adı ve şifre bilgileri gerekli. Devam edebilmek için bu alanları doldurmalısınız.');
                    return;
                }

                var ifdt = '{' + 'v1:"{0}",v2:"{1}",v4:"{2}"'.format(host, user, root) + '}';
                $.cookie('ifdt', null);
                $.cookie('ifdt', ifdt, { expires: "365", path: '/' });

                var postdata = pagesdata + '&v1={0}&v2={1}&v3={2}&v4={3}'.format(host, user, pass, root);

                var url = "/PublishToServerHandler.ashx";

                dialogContent.hide();
                btnarea.hide();
                progresstitle.text("İşlem Devam Ediyor...");
                loading.show();
                info.show();
                newwindow.show();
                continuebtn.hide();
                progressField.show();

                info.html("Lütfen işlem sonlanana kadar bu pencereyi kapatmayın.");

                $.post(url, postdata, function (data) {

                    progresstitle.text("İşlem Başarıyla Tamamlandı.");
                    loading.hide();
                    info.html("Devam etmek için 'Tamam'a tıklayabilirsiniz.");
                    newwindow.hide();
                    continuebtn.find(".fancy").unbind();
                    continuebtn.find(".fancy").click(function () {
                        window.location.reload(true);
                        dialog.remove();
                        overlay.remove();
                    });
                    continuebtn.show();

                }).fail(function () {

                    progresstitle.text("İşlem Tamamlanamadı!");
                    loading.hide();
                    info.html("Bir hata oluştu ve işlem tamamlanamadı. Girdiğiniz bilgilerin doğruluğunu, ftp sunucunuzun çalışır durumda olduğunu ve yazma izniniz olduğunu kontrol etmelisiniz.");
                    newwindow.hide();
                    continuebtn.show();

                });


            });

            cancelbtn.click(function () {
                dialog.remove();
                overlay.remove();
            });

        });
    }

    var errormessage = $.trim($(".form-block.result-message").text());

    if (errormessage != "") {
        //window.scrollTo(0, 0);
        //esnScrollToTop = true;
    }

});


